/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * A labeling of text.  Really a list of Spans.
 * 
 * <code>labels</code> - the labels for this labeling. Each label represented as a Span.<br/>
 * <code>source</code> - the source annotator this labeling came from.<br/>
 * <code>score</code> - the score for this labeling.<br/>
 * <code>rawText</code> - the raw text for this labeling (if null then consult the labeling's parent's rawText field, i.e., the Record's)
 */
public class Labeling implements TBase<Labeling, Labeling._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Labeling");

  private static final TField LABELS_FIELD_DESC = new TField("labels", TType.LIST, (short)1);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)2);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)3);
  private static final TField RAW_TEXT_FIELD_DESC = new TField("rawText", TType.STRING, (short)4);

  /**
   * the labels as spans.
   */
  public List<Span> labels;
  /**
   * the source of this labeling came from.
   */
  public String source;
  /**
   * score for this labeling.
   */
  public double score;
  /**
   * the raw text for this labeling (if null then consult the labeling's parent's rawText field)
   */
  public String rawText;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * the labels as spans.
     */
    LABELS((short)1, "labels"),
    /**
     * the source of this labeling came from.
     */
    SOURCE((short)2, "source"),
    /**
     * score for this labeling.
     */
    SCORE((short)3, "score"),
    /**
     * the raw text for this labeling (if null then consult the labeling's parent's rawText field)
     */
    RAW_TEXT((short)4, "rawText");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // LABELS
          return LABELS;
        case 2: // SOURCE
          return SOURCE;
        case 3: // SCORE
          return SCORE;
        case 4: // RAW_TEXT
          return RAW_TEXT;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __SCORE_ISSET_ID = 0;
  private BitSet __isset_bit_vector = new BitSet(1);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.LABELS, new FieldMetaData("labels", TFieldRequirementType.REQUIRED, 
        new ListMetaData(TType.LIST, 
            new StructMetaData(TType.STRUCT, Span.class))));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    tmpMap.put(_Fields.RAW_TEXT, new FieldMetaData("rawText", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(Labeling.class, metaDataMap);
  }

  public Labeling() {
  }

  public Labeling(
    List<Span> labels)
  {
    this();
    this.labels = labels;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Labeling(Labeling other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetLabels()) {
      List<Span> __this__labels = new ArrayList<Span>();
      for (Span other_element : other.labels) {
        __this__labels.add(new Span(other_element));
      }
      this.labels = __this__labels;
    }
    if (other.isSetSource()) {
      this.source = other.source;
    }
    this.score = other.score;
    if (other.isSetRawText()) {
      this.rawText = other.rawText;
    }
  }

  public Labeling deepCopy() {
    return new Labeling(this);
  }

  @Deprecated
  public Labeling clone() {
    return new Labeling(this);
  }

  @Override
  public void clear() {
    this.labels = null;
    this.source = null;
    setScoreIsSet(false);
    this.score = 0.0;
    this.rawText = null;
  }

  public int getLabelsSize() {
    return (this.labels == null) ? 0 : this.labels.size();
  }

  public java.util.Iterator<Span> getLabelsIterator() {
    return (this.labels == null) ? null : this.labels.iterator();
  }

  public void addToLabels(Span elem) {
    if (this.labels == null) {
      this.labels = new ArrayList<Span>();
    }
    this.labels.add(elem);
  }

  /**
   * the labels as spans.
   */
  public List<Span> getLabels() {
    return this.labels;
  }

  /**
   * the labels as spans.
   */
  public Labeling setLabels(List<Span> labels) {
    this.labels = labels;
    return this;
  }

  public void unsetLabels() {
    this.labels = null;
  }

  /** Returns true if field labels is set (has been asigned a value) and false otherwise */
  public boolean isSetLabels() {
    return this.labels != null;
  }

  public void setLabelsIsSet(boolean value) {
    if (!value) {
      this.labels = null;
    }
  }

  /**
   * the source of this labeling came from.
   */
  public String getSource() {
    return this.source;
  }

  /**
   * the source of this labeling came from.
   */
  public Labeling setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  /**
   * score for this labeling.
   */
  public double getScore() {
    return this.score;
  }

  /**
   * score for this labeling.
   */
  public Labeling setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  /**
   * the raw text for this labeling (if null then consult the labeling's parent's rawText field)
   */
  public String getRawText() {
    return this.rawText;
  }

  /**
   * the raw text for this labeling (if null then consult the labeling's parent's rawText field)
   */
  public Labeling setRawText(String rawText) {
    this.rawText = rawText;
    return this;
  }

  public void unsetRawText() {
    this.rawText = null;
  }

  /** Returns true if field rawText is set (has been asigned a value) and false otherwise */
  public boolean isSetRawText() {
    return this.rawText != null;
  }

  public void setRawTextIsSet(boolean value) {
    if (!value) {
      this.rawText = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case LABELS:
      if (value == null) {
        unsetLabels();
      } else {
        setLabels((List<Span>)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    case RAW_TEXT:
      if (value == null) {
        unsetRawText();
      } else {
        setRawText((String)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case LABELS:
      return getLabels();

    case SOURCE:
      return getSource();

    case SCORE:
      return new Double(getScore());

    case RAW_TEXT:
      return getRawText();

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case LABELS:
      return isSetLabels();
    case SOURCE:
      return isSetSource();
    case SCORE:
      return isSetScore();
    case RAW_TEXT:
      return isSetRawText();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Labeling)
      return this.equals((Labeling)that);
    return false;
  }

  public boolean equals(Labeling that) {
    if (that == null)
      return false;

    boolean this_present_labels = true && this.isSetLabels();
    boolean that_present_labels = true && that.isSetLabels();
    if (this_present_labels || that_present_labels) {
      if (!(this_present_labels && that_present_labels))
        return false;
      if (!this.labels.equals(that.labels))
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    boolean this_present_rawText = true && this.isSetRawText();
    boolean that_present_rawText = true && that.isSetRawText();
    if (this_present_rawText || that_present_rawText) {
      if (!(this_present_rawText && that_present_rawText))
        return false;
      if (!this.rawText.equals(that.rawText))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_labels = true && (isSetLabels());
    builder.append(present_labels);
    if (present_labels)
      builder.append(labels);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    boolean present_rawText = true && (isSetRawText());
    builder.append(present_rawText);
    if (present_rawText)
      builder.append(rawText);

    return builder.toHashCode();
  }

  public int compareTo(Labeling other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Labeling typedOther = (Labeling)other;

    lastComparison = Boolean.valueOf(isSetLabels()).compareTo(typedOther.isSetLabels());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetLabels()) {      lastComparison = TBaseHelper.compareTo(this.labels, typedOther.labels);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRawText()).compareTo(typedOther.isSetRawText());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRawText()) {      lastComparison = TBaseHelper.compareTo(this.rawText, typedOther.rawText);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // LABELS
          if (field.type == TType.LIST) {
            {
              TList _list5 = iprot.readListBegin();
              this.labels = new ArrayList<Span>(_list5.size);
              for (int _i6 = 0; _i6 < _list5.size; ++_i6)
              {
                Span _elem7;
                _elem7 = new Span();
                _elem7.read(iprot);
                this.labels.add(_elem7);
              }
              iprot.readListEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // RAW_TEXT
          if (field.type == TType.STRING) {
            this.rawText = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.labels != null) {
      oprot.writeFieldBegin(LABELS_FIELD_DESC);
      {
        oprot.writeListBegin(new TList(TType.STRUCT, this.labels.size()));
        for (Span _iter8 : this.labels)
        {
          _iter8.write(oprot);
        }
        oprot.writeListEnd();
      }
      oprot.writeFieldEnd();
    }
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    if (this.rawText != null) {
      if (isSetRawText()) {
        oprot.writeFieldBegin(RAW_TEXT_FIELD_DESC);
        oprot.writeString(this.rawText);
        oprot.writeFieldEnd();
      }
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Labeling(");
    boolean first = true;

    sb.append("labels:");
    if (this.labels == null) {
      sb.append("null");
    } else {
      sb.append(this.labels);
    }
    first = false;
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    if (isSetRawText()) {
      if (!first) sb.append(", ");
      sb.append("rawText:");
      if (this.rawText == null) {
        sb.append("null");
      } else {
        sb.append(this.rawText);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (labels == null) {
      throw new TProtocolException("Required field 'labels' was not present! Struct: " + toString());
    }
  }

}

