/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * Nodes store their children.  Referenced as index into list<Node> in
 * the containing struct.
 * Here the link between Node can be labeled.
 * 
 * <code>label</code> - the label for this Node.<br/>
 * <code>span</code> - the span this node covers.<br/>
 * <code>children</code> -  the children of the node represented as a map of <child index, edge label>. Empty string implies no label. The index is the index of the node in the parent data structure (i.e., the tree's nodes).<br/>
 * <code>source</code> - the source annotator this node came from.<br/>
 * <code>score</code> - the score for this node.<br/>
 */
public class Node implements TBase<Node, Node._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Node");

  private static final TField LABEL_FIELD_DESC = new TField("label", TType.STRING, (short)1);
  private static final TField SPAN_FIELD_DESC = new TField("span", TType.STRUCT, (short)2);
  private static final TField CHILDREN_FIELD_DESC = new TField("children", TType.MAP, (short)3);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)4);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)5);

  /**
   * the label of the node.
   */
  public String label;
  /**
   * the span this node covers.
   */
  public Span span;
  /**
   * the children of the node represented as a map of <child index, edge label>. Empty string implies no label.
   */
  public Map<Integer,String> children;
  /**
   * source of the node .
   */
  public String source;
  /**
   * the score for this node.
   */
  public double score;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * the label of the node.
     */
    LABEL((short)1, "label"),
    /**
     * the span this node covers.
     */
    SPAN((short)2, "span"),
    /**
     * the children of the node represented as a map of <child index, edge label>. Empty string implies no label.
     */
    CHILDREN((short)3, "children"),
    /**
     * source of the node .
     */
    SOURCE((short)4, "source"),
    /**
     * the score for this node.
     */
    SCORE((short)5, "score");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // LABEL
          return LABEL;
        case 2: // SPAN
          return SPAN;
        case 3: // CHILDREN
          return CHILDREN;
        case 4: // SOURCE
          return SOURCE;
        case 5: // SCORE
          return SCORE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __SCORE_ISSET_ID = 0;
  private BitSet __isset_bit_vector = new BitSet(1);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.LABEL, new FieldMetaData("label", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.SPAN, new FieldMetaData("span", TFieldRequirementType.OPTIONAL, 
        new StructMetaData(TType.STRUCT, Span.class)));
    tmpMap.put(_Fields.CHILDREN, new FieldMetaData("children", TFieldRequirementType.OPTIONAL, 
        new MapMetaData(TType.MAP, 
            new FieldValueMetaData(TType.I32), 
            new FieldValueMetaData(TType.STRING))));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(Node.class, metaDataMap);
  }

  public Node() {
  }

  public Node(
    String label)
  {
    this();
    this.label = label;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Node(Node other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetLabel()) {
      this.label = other.label;
    }
    if (other.isSetSpan()) {
      this.span = new Span(other.span);
    }
    if (other.isSetChildren()) {
      Map<Integer,String> __this__children = new HashMap<Integer,String>();
      for (Map.Entry<Integer, String> other_element : other.children.entrySet()) {

        Integer other_element_key = other_element.getKey();
        String other_element_value = other_element.getValue();

        Integer __this__children_copy_key = other_element_key;

        String __this__children_copy_value = other_element_value;

        __this__children.put(__this__children_copy_key, __this__children_copy_value);
      }
      this.children = __this__children;
    }
    if (other.isSetSource()) {
      this.source = other.source;
    }
    this.score = other.score;
  }

  public Node deepCopy() {
    return new Node(this);
  }

  @Deprecated
  public Node clone() {
    return new Node(this);
  }

  @Override
  public void clear() {
    this.label = null;
    this.span = null;
    this.children = null;
    this.source = null;
    setScoreIsSet(false);
    this.score = 0.0;
  }

  /**
   * the label of the node.
   */
  public String getLabel() {
    return this.label;
  }

  /**
   * the label of the node.
   */
  public Node setLabel(String label) {
    this.label = label;
    return this;
  }

  public void unsetLabel() {
    this.label = null;
  }

  /** Returns true if field label is set (has been asigned a value) and false otherwise */
  public boolean isSetLabel() {
    return this.label != null;
  }

  public void setLabelIsSet(boolean value) {
    if (!value) {
      this.label = null;
    }
  }

  /**
   * the span this node covers.
   */
  public Span getSpan() {
    return this.span;
  }

  /**
   * the span this node covers.
   */
  public Node setSpan(Span span) {
    this.span = span;
    return this;
  }

  public void unsetSpan() {
    this.span = null;
  }

  /** Returns true if field span is set (has been asigned a value) and false otherwise */
  public boolean isSetSpan() {
    return this.span != null;
  }

  public void setSpanIsSet(boolean value) {
    if (!value) {
      this.span = null;
    }
  }

  public int getChildrenSize() {
    return (this.children == null) ? 0 : this.children.size();
  }

  public void putToChildren(int key, String val) {
    if (this.children == null) {
      this.children = new HashMap<Integer,String>();
    }
    this.children.put(key, val);
  }

  /**
   * the children of the node represented as a map of <child index, edge label>. Empty string implies no label.
   */
  public Map<Integer,String> getChildren() {
    return this.children;
  }

  /**
   * the children of the node represented as a map of <child index, edge label>. Empty string implies no label.
   */
  public Node setChildren(Map<Integer,String> children) {
    this.children = children;
    return this;
  }

  public void unsetChildren() {
    this.children = null;
  }

  /** Returns true if field children is set (has been asigned a value) and false otherwise */
  public boolean isSetChildren() {
    return this.children != null;
  }

  public void setChildrenIsSet(boolean value) {
    if (!value) {
      this.children = null;
    }
  }

  /**
   * source of the node .
   */
  public String getSource() {
    return this.source;
  }

  /**
   * source of the node .
   */
  public Node setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  /**
   * the score for this node.
   */
  public double getScore() {
    return this.score;
  }

  /**
   * the score for this node.
   */
  public Node setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case LABEL:
      if (value == null) {
        unsetLabel();
      } else {
        setLabel((String)value);
      }
      break;

    case SPAN:
      if (value == null) {
        unsetSpan();
      } else {
        setSpan((Span)value);
      }
      break;

    case CHILDREN:
      if (value == null) {
        unsetChildren();
      } else {
        setChildren((Map<Integer,String>)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case LABEL:
      return getLabel();

    case SPAN:
      return getSpan();

    case CHILDREN:
      return getChildren();

    case SOURCE:
      return getSource();

    case SCORE:
      return new Double(getScore());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case LABEL:
      return isSetLabel();
    case SPAN:
      return isSetSpan();
    case CHILDREN:
      return isSetChildren();
    case SOURCE:
      return isSetSource();
    case SCORE:
      return isSetScore();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Node)
      return this.equals((Node)that);
    return false;
  }

  public boolean equals(Node that) {
    if (that == null)
      return false;

    boolean this_present_label = true && this.isSetLabel();
    boolean that_present_label = true && that.isSetLabel();
    if (this_present_label || that_present_label) {
      if (!(this_present_label && that_present_label))
        return false;
      if (!this.label.equals(that.label))
        return false;
    }

    boolean this_present_span = true && this.isSetSpan();
    boolean that_present_span = true && that.isSetSpan();
    if (this_present_span || that_present_span) {
      if (!(this_present_span && that_present_span))
        return false;
      if (!this.span.equals(that.span))
        return false;
    }

    boolean this_present_children = true && this.isSetChildren();
    boolean that_present_children = true && that.isSetChildren();
    if (this_present_children || that_present_children) {
      if (!(this_present_children && that_present_children))
        return false;
      if (!this.children.equals(that.children))
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_label = true && (isSetLabel());
    builder.append(present_label);
    if (present_label)
      builder.append(label);

    boolean present_span = true && (isSetSpan());
    builder.append(present_span);
    if (present_span)
      builder.append(span);

    boolean present_children = true && (isSetChildren());
    builder.append(present_children);
    if (present_children)
      builder.append(children);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    return builder.toHashCode();
  }

  public int compareTo(Node other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Node typedOther = (Node)other;

    lastComparison = Boolean.valueOf(isSetLabel()).compareTo(typedOther.isSetLabel());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetLabel()) {      lastComparison = TBaseHelper.compareTo(this.label, typedOther.label);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSpan()).compareTo(typedOther.isSetSpan());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSpan()) {      lastComparison = TBaseHelper.compareTo(this.span, typedOther.span);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetChildren()).compareTo(typedOther.isSetChildren());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetChildren()) {      lastComparison = TBaseHelper.compareTo(this.children, typedOther.children);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // LABEL
          if (field.type == TType.STRING) {
            this.label = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // SPAN
          if (field.type == TType.STRUCT) {
            this.span = new Span();
            this.span.read(iprot);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // CHILDREN
          if (field.type == TType.MAP) {
            {
              TMap _map13 = iprot.readMapBegin();
              this.children = new HashMap<Integer,String>(2*_map13.size);
              for (int _i14 = 0; _i14 < _map13.size; ++_i14)
              {
                int _key15;
                String _val16;
                _key15 = iprot.readI32();
                _val16 = iprot.readString();
                this.children.put(_key15, _val16);
              }
              iprot.readMapEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.label != null) {
      oprot.writeFieldBegin(LABEL_FIELD_DESC);
      oprot.writeString(this.label);
      oprot.writeFieldEnd();
    }
    if (this.span != null) {
      if (isSetSpan()) {
        oprot.writeFieldBegin(SPAN_FIELD_DESC);
        this.span.write(oprot);
        oprot.writeFieldEnd();
      }
    }
    if (this.children != null) {
      if (isSetChildren()) {
        oprot.writeFieldBegin(CHILDREN_FIELD_DESC);
        {
          oprot.writeMapBegin(new TMap(TType.I32, TType.STRING, this.children.size()));
          for (Map.Entry<Integer, String> _iter17 : this.children.entrySet())
          {
            oprot.writeI32(_iter17.getKey());
            oprot.writeString(_iter17.getValue());
          }
          oprot.writeMapEnd();
        }
        oprot.writeFieldEnd();
      }
    }
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Node(");
    boolean first = true;

    sb.append("label:");
    if (this.label == null) {
      sb.append("null");
    } else {
      sb.append(this.label);
    }
    first = false;
    if (isSetSpan()) {
      if (!first) sb.append(", ");
      sb.append("span:");
      if (this.span == null) {
        sb.append("null");
      } else {
        sb.append(this.span);
      }
      first = false;
    }
    if (isSetChildren()) {
      if (!first) sb.append(", ");
      sb.append("children:");
      if (this.children == null) {
        sb.append("null");
      } else {
        sb.append(this.children);
      }
      first = false;
    }
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (label == null) {
      throw new TProtocolException("Required field 'label' was not present! Struct: " + toString());
    }
  }

}

