/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * Relations are between two spans.
 * 
 * <code>start</code> - the index of the span that starts this relation.<br/>
 * <code>ending</code> - the index of the span that ends this relation.<br/>
 * <code>label</code> - the label for this relation.<br/>
 * <code>source</code> - where this relation came from.<br/>
 * <code>score</code> - the score for this relation.<br/>
 */
public class Relation implements TBase<Relation, Relation._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Relation");

  private static final TField START_FIELD_DESC = new TField("start", TType.I32, (short)1);
  private static final TField ENDING_FIELD_DESC = new TField("ending", TType.I32, (short)2);
  private static final TField LABEL_FIELD_DESC = new TField("label", TType.STRING, (short)3);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)4);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)5);

  public int start;
  public int ending;
  public String label;
  public String source;
  public double score;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    START((short)1, "start"),
    ENDING((short)2, "ending"),
    LABEL((short)3, "label"),
    SOURCE((short)4, "source"),
    SCORE((short)5, "score");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // START
          return START;
        case 2: // ENDING
          return ENDING;
        case 3: // LABEL
          return LABEL;
        case 4: // SOURCE
          return SOURCE;
        case 5: // SCORE
          return SCORE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __START_ISSET_ID = 0;
  private static final int __ENDING_ISSET_ID = 1;
  private static final int __SCORE_ISSET_ID = 2;
  private BitSet __isset_bit_vector = new BitSet(3);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.START, new FieldMetaData("start", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.ENDING, new FieldMetaData("ending", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.LABEL, new FieldMetaData("label", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(Relation.class, metaDataMap);
  }

  public Relation() {
  }

  public Relation(
    int start,
    int ending)
  {
    this();
    this.start = start;
    setStartIsSet(true);
    this.ending = ending;
    setEndingIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Relation(Relation other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.start = other.start;
    this.ending = other.ending;
    if (other.isSetLabel()) {
      this.label = other.label;
    }
    if (other.isSetSource()) {
      this.source = other.source;
    }
    this.score = other.score;
  }

  public Relation deepCopy() {
    return new Relation(this);
  }

  @Deprecated
  public Relation clone() {
    return new Relation(this);
  }

  @Override
  public void clear() {
    setStartIsSet(false);
    this.start = 0;
    setEndingIsSet(false);
    this.ending = 0;
    this.label = null;
    this.source = null;
    setScoreIsSet(false);
    this.score = 0.0;
  }

  public int getStart() {
    return this.start;
  }

  public Relation setStart(int start) {
    this.start = start;
    setStartIsSet(true);
    return this;
  }

  public void unsetStart() {
    __isset_bit_vector.clear(__START_ISSET_ID);
  }

  /** Returns true if field start is set (has been asigned a value) and false otherwise */
  public boolean isSetStart() {
    return __isset_bit_vector.get(__START_ISSET_ID);
  }

  public void setStartIsSet(boolean value) {
    __isset_bit_vector.set(__START_ISSET_ID, value);
  }

  public int getEnding() {
    return this.ending;
  }

  public Relation setEnding(int ending) {
    this.ending = ending;
    setEndingIsSet(true);
    return this;
  }

  public void unsetEnding() {
    __isset_bit_vector.clear(__ENDING_ISSET_ID);
  }

  /** Returns true if field ending is set (has been asigned a value) and false otherwise */
  public boolean isSetEnding() {
    return __isset_bit_vector.get(__ENDING_ISSET_ID);
  }

  public void setEndingIsSet(boolean value) {
    __isset_bit_vector.set(__ENDING_ISSET_ID, value);
  }

  public String getLabel() {
    return this.label;
  }

  public Relation setLabel(String label) {
    this.label = label;
    return this;
  }

  public void unsetLabel() {
    this.label = null;
  }

  /** Returns true if field label is set (has been asigned a value) and false otherwise */
  public boolean isSetLabel() {
    return this.label != null;
  }

  public void setLabelIsSet(boolean value) {
    if (!value) {
      this.label = null;
    }
  }

  public String getSource() {
    return this.source;
  }

  public Relation setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  public double getScore() {
    return this.score;
  }

  public Relation setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case START:
      if (value == null) {
        unsetStart();
      } else {
        setStart((Integer)value);
      }
      break;

    case ENDING:
      if (value == null) {
        unsetEnding();
      } else {
        setEnding((Integer)value);
      }
      break;

    case LABEL:
      if (value == null) {
        unsetLabel();
      } else {
        setLabel((String)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case START:
      return new Integer(getStart());

    case ENDING:
      return new Integer(getEnding());

    case LABEL:
      return getLabel();

    case SOURCE:
      return getSource();

    case SCORE:
      return new Double(getScore());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case START:
      return isSetStart();
    case ENDING:
      return isSetEnding();
    case LABEL:
      return isSetLabel();
    case SOURCE:
      return isSetSource();
    case SCORE:
      return isSetScore();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Relation)
      return this.equals((Relation)that);
    return false;
  }

  public boolean equals(Relation that) {
    if (that == null)
      return false;

    boolean this_present_start = true;
    boolean that_present_start = true;
    if (this_present_start || that_present_start) {
      if (!(this_present_start && that_present_start))
        return false;
      if (this.start != that.start)
        return false;
    }

    boolean this_present_ending = true;
    boolean that_present_ending = true;
    if (this_present_ending || that_present_ending) {
      if (!(this_present_ending && that_present_ending))
        return false;
      if (this.ending != that.ending)
        return false;
    }

    boolean this_present_label = true && this.isSetLabel();
    boolean that_present_label = true && that.isSetLabel();
    if (this_present_label || that_present_label) {
      if (!(this_present_label && that_present_label))
        return false;
      if (!this.label.equals(that.label))
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_start = true;
    builder.append(present_start);
    if (present_start)
      builder.append(start);

    boolean present_ending = true;
    builder.append(present_ending);
    if (present_ending)
      builder.append(ending);

    boolean present_label = true && (isSetLabel());
    builder.append(present_label);
    if (present_label)
      builder.append(label);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    return builder.toHashCode();
  }

  public int compareTo(Relation other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Relation typedOther = (Relation)other;

    lastComparison = Boolean.valueOf(isSetStart()).compareTo(typedOther.isSetStart());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetStart()) {      lastComparison = TBaseHelper.compareTo(this.start, typedOther.start);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetEnding()).compareTo(typedOther.isSetEnding());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetEnding()) {      lastComparison = TBaseHelper.compareTo(this.ending, typedOther.ending);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetLabel()).compareTo(typedOther.isSetLabel());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetLabel()) {      lastComparison = TBaseHelper.compareTo(this.label, typedOther.label);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // START
          if (field.type == TType.I32) {
            this.start = iprot.readI32();
            setStartIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // ENDING
          if (field.type == TType.I32) {
            this.ending = iprot.readI32();
            setEndingIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // LABEL
          if (field.type == TType.STRING) {
            this.label = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    if (!isSetStart()) {
      throw new TProtocolException("Required field 'start' was not found in serialized data! Struct: " + toString());
    }
    if (!isSetEnding()) {
      throw new TProtocolException("Required field 'ending' was not found in serialized data! Struct: " + toString());
    }
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(START_FIELD_DESC);
    oprot.writeI32(this.start);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(ENDING_FIELD_DESC);
    oprot.writeI32(this.ending);
    oprot.writeFieldEnd();
    if (this.label != null) {
      if (isSetLabel()) {
        oprot.writeFieldBegin(LABEL_FIELD_DESC);
        oprot.writeString(this.label);
        oprot.writeFieldEnd();
      }
    }
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Relation(");
    boolean first = true;

    sb.append("start:");
    sb.append(this.start);
    first = false;
    if (!first) sb.append(", ");
    sb.append("ending:");
    sb.append(this.ending);
    first = false;
    if (isSetLabel()) {
      if (!first) sb.append(", ");
      sb.append("label:");
      if (this.label == null) {
        sb.append("null");
      } else {
        sb.append(this.label);
      }
      first = false;
    }
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    // alas, we cannot check 'start' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'ending' because it's a primitive and you chose the non-beans generator.
  }

}

