/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * Span covers a portion of text.
 * 
 * <code>start</code> - start index of span in the raw text (inclusive).<br/>
 * <code>ending</code> - end index of span in the raw text (exclusive).<br/>
 * <code>label</code> - label for span.<br/>
 * <code>score</code> - score of span.<br/>
 * <code>source</code> - the source annotator of this span.<br/>
 * <code>attributes</code> - any additional attributes assoicated with this span. a map of attribute_name => value.<br/>
 * <code>multiIndex</code> - if associated with a MultiRecord which Record object is this span for.
 * 
 */
public class Span implements TBase<Span, Span._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Span");

  private static final TField START_FIELD_DESC = new TField("start", TType.I32, (short)1);
  private static final TField ENDING_FIELD_DESC = new TField("ending", TType.I32, (short)2);
  private static final TField LABEL_FIELD_DESC = new TField("label", TType.STRING, (short)3);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)4);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)5);
  private static final TField ATTRIBUTES_FIELD_DESC = new TField("attributes", TType.MAP, (short)6);
  private static final TField MULTI_INDEX_FIELD_DESC = new TField("multiIndex", TType.I32, (short)7);

  /**
   * start index of span in the raw text (inclusive).
   */
  public int start;
  /**
   * ending index of span in the raw text (exclusive).
   */
  public int ending;
  /**
   * label for span.
   */
  public String label;
  /**
   * score of span.
   */
  public double score;
  /**
   * source of span.
   */
  public String source;
  /**
   * any additional attributes assoicated with this span.
   */
  public Map<String,String> attributes;
  /**
   * index of the text (in the multirecord) to which this span references.
   */
  public int multiIndex;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * start index of span in the raw text (inclusive).
     */
    START((short)1, "start"),
    /**
     * ending index of span in the raw text (exclusive).
     */
    ENDING((short)2, "ending"),
    /**
     * label for span.
     */
    LABEL((short)3, "label"),
    /**
     * score of span.
     */
    SCORE((short)4, "score"),
    /**
     * source of span.
     */
    SOURCE((short)5, "source"),
    /**
     * any additional attributes assoicated with this span.
     */
    ATTRIBUTES((short)6, "attributes"),
    /**
     * index of the text (in the multirecord) to which this span references.
     */
    MULTI_INDEX((short)7, "multiIndex");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // START
          return START;
        case 2: // ENDING
          return ENDING;
        case 3: // LABEL
          return LABEL;
        case 4: // SCORE
          return SCORE;
        case 5: // SOURCE
          return SOURCE;
        case 6: // ATTRIBUTES
          return ATTRIBUTES;
        case 7: // MULTI_INDEX
          return MULTI_INDEX;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __START_ISSET_ID = 0;
  private static final int __ENDING_ISSET_ID = 1;
  private static final int __SCORE_ISSET_ID = 2;
  private static final int __MULTIINDEX_ISSET_ID = 3;
  private BitSet __isset_bit_vector = new BitSet(4);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.START, new FieldMetaData("start", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.ENDING, new FieldMetaData("ending", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.LABEL, new FieldMetaData("label", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.ATTRIBUTES, new FieldMetaData("attributes", TFieldRequirementType.OPTIONAL, 
        new MapMetaData(TType.MAP, 
            new FieldValueMetaData(TType.STRING), 
            new FieldValueMetaData(TType.STRING))));
    tmpMap.put(_Fields.MULTI_INDEX, new FieldMetaData("multiIndex", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I32)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(Span.class, metaDataMap);
  }

  public Span() {
  }

  public Span(
    int start,
    int ending)
  {
    this();
    this.start = start;
    setStartIsSet(true);
    this.ending = ending;
    setEndingIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Span(Span other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.start = other.start;
    this.ending = other.ending;
    if (other.isSetLabel()) {
      this.label = other.label;
    }
    this.score = other.score;
    if (other.isSetSource()) {
      this.source = other.source;
    }
    if (other.isSetAttributes()) {
      Map<String,String> __this__attributes = new HashMap<String,String>();
      for (Map.Entry<String, String> other_element : other.attributes.entrySet()) {

        String other_element_key = other_element.getKey();
        String other_element_value = other_element.getValue();

        String __this__attributes_copy_key = other_element_key;

        String __this__attributes_copy_value = other_element_value;

        __this__attributes.put(__this__attributes_copy_key, __this__attributes_copy_value);
      }
      this.attributes = __this__attributes;
    }
    this.multiIndex = other.multiIndex;
  }

  public Span deepCopy() {
    return new Span(this);
  }

  @Deprecated
  public Span clone() {
    return new Span(this);
  }

  @Override
  public void clear() {
    setStartIsSet(false);
    this.start = 0;
    setEndingIsSet(false);
    this.ending = 0;
    this.label = null;
    setScoreIsSet(false);
    this.score = 0.0;
    this.source = null;
    this.attributes = null;
    setMultiIndexIsSet(false);
    this.multiIndex = 0;
  }

  /**
   * start index of span in the raw text (inclusive).
   */
  public int getStart() {
    return this.start;
  }

  /**
   * start index of span in the raw text (inclusive).
   */
  public Span setStart(int start) {
    this.start = start;
    setStartIsSet(true);
    return this;
  }

  public void unsetStart() {
    __isset_bit_vector.clear(__START_ISSET_ID);
  }

  /** Returns true if field start is set (has been asigned a value) and false otherwise */
  public boolean isSetStart() {
    return __isset_bit_vector.get(__START_ISSET_ID);
  }

  public void setStartIsSet(boolean value) {
    __isset_bit_vector.set(__START_ISSET_ID, value);
  }

  /**
   * ending index of span in the raw text (exclusive).
   */
  public int getEnding() {
    return this.ending;
  }

  /**
   * ending index of span in the raw text (exclusive).
   */
  public Span setEnding(int ending) {
    this.ending = ending;
    setEndingIsSet(true);
    return this;
  }

  public void unsetEnding() {
    __isset_bit_vector.clear(__ENDING_ISSET_ID);
  }

  /** Returns true if field ending is set (has been asigned a value) and false otherwise */
  public boolean isSetEnding() {
    return __isset_bit_vector.get(__ENDING_ISSET_ID);
  }

  public void setEndingIsSet(boolean value) {
    __isset_bit_vector.set(__ENDING_ISSET_ID, value);
  }

  /**
   * label for span.
   */
  public String getLabel() {
    return this.label;
  }

  /**
   * label for span.
   */
  public Span setLabel(String label) {
    this.label = label;
    return this;
  }

  public void unsetLabel() {
    this.label = null;
  }

  /** Returns true if field label is set (has been asigned a value) and false otherwise */
  public boolean isSetLabel() {
    return this.label != null;
  }

  public void setLabelIsSet(boolean value) {
    if (!value) {
      this.label = null;
    }
  }

  /**
   * score of span.
   */
  public double getScore() {
    return this.score;
  }

  /**
   * score of span.
   */
  public Span setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  /**
   * source of span.
   */
  public String getSource() {
    return this.source;
  }

  /**
   * source of span.
   */
  public Span setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  public int getAttributesSize() {
    return (this.attributes == null) ? 0 : this.attributes.size();
  }

  public void putToAttributes(String key, String val) {
    if (this.attributes == null) {
      this.attributes = new HashMap<String,String>();
    }
    this.attributes.put(key, val);
  }

  /**
   * any additional attributes assoicated with this span.
   */
  public Map<String,String> getAttributes() {
    return this.attributes;
  }

  /**
   * any additional attributes assoicated with this span.
   */
  public Span setAttributes(Map<String,String> attributes) {
    this.attributes = attributes;
    return this;
  }

  public void unsetAttributes() {
    this.attributes = null;
  }

  /** Returns true if field attributes is set (has been asigned a value) and false otherwise */
  public boolean isSetAttributes() {
    return this.attributes != null;
  }

  public void setAttributesIsSet(boolean value) {
    if (!value) {
      this.attributes = null;
    }
  }

  /**
   * index of the text (in the multirecord) to which this span references.
   */
  public int getMultiIndex() {
    return this.multiIndex;
  }

  /**
   * index of the text (in the multirecord) to which this span references.
   */
  public Span setMultiIndex(int multiIndex) {
    this.multiIndex = multiIndex;
    setMultiIndexIsSet(true);
    return this;
  }

  public void unsetMultiIndex() {
    __isset_bit_vector.clear(__MULTIINDEX_ISSET_ID);
  }

  /** Returns true if field multiIndex is set (has been asigned a value) and false otherwise */
  public boolean isSetMultiIndex() {
    return __isset_bit_vector.get(__MULTIINDEX_ISSET_ID);
  }

  public void setMultiIndexIsSet(boolean value) {
    __isset_bit_vector.set(__MULTIINDEX_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case START:
      if (value == null) {
        unsetStart();
      } else {
        setStart((Integer)value);
      }
      break;

    case ENDING:
      if (value == null) {
        unsetEnding();
      } else {
        setEnding((Integer)value);
      }
      break;

    case LABEL:
      if (value == null) {
        unsetLabel();
      } else {
        setLabel((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case ATTRIBUTES:
      if (value == null) {
        unsetAttributes();
      } else {
        setAttributes((Map<String,String>)value);
      }
      break;

    case MULTI_INDEX:
      if (value == null) {
        unsetMultiIndex();
      } else {
        setMultiIndex((Integer)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case START:
      return new Integer(getStart());

    case ENDING:
      return new Integer(getEnding());

    case LABEL:
      return getLabel();

    case SCORE:
      return new Double(getScore());

    case SOURCE:
      return getSource();

    case ATTRIBUTES:
      return getAttributes();

    case MULTI_INDEX:
      return new Integer(getMultiIndex());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case START:
      return isSetStart();
    case ENDING:
      return isSetEnding();
    case LABEL:
      return isSetLabel();
    case SCORE:
      return isSetScore();
    case SOURCE:
      return isSetSource();
    case ATTRIBUTES:
      return isSetAttributes();
    case MULTI_INDEX:
      return isSetMultiIndex();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Span)
      return this.equals((Span)that);
    return false;
  }

  public boolean equals(Span that) {
    if (that == null)
      return false;

    boolean this_present_start = true;
    boolean that_present_start = true;
    if (this_present_start || that_present_start) {
      if (!(this_present_start && that_present_start))
        return false;
      if (this.start != that.start)
        return false;
    }

    boolean this_present_ending = true;
    boolean that_present_ending = true;
    if (this_present_ending || that_present_ending) {
      if (!(this_present_ending && that_present_ending))
        return false;
      if (this.ending != that.ending)
        return false;
    }

    boolean this_present_label = true && this.isSetLabel();
    boolean that_present_label = true && that.isSetLabel();
    if (this_present_label || that_present_label) {
      if (!(this_present_label && that_present_label))
        return false;
      if (!this.label.equals(that.label))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_attributes = true && this.isSetAttributes();
    boolean that_present_attributes = true && that.isSetAttributes();
    if (this_present_attributes || that_present_attributes) {
      if (!(this_present_attributes && that_present_attributes))
        return false;
      if (!this.attributes.equals(that.attributes))
        return false;
    }

    boolean this_present_multiIndex = true && this.isSetMultiIndex();
    boolean that_present_multiIndex = true && that.isSetMultiIndex();
    if (this_present_multiIndex || that_present_multiIndex) {
      if (!(this_present_multiIndex && that_present_multiIndex))
        return false;
      if (this.multiIndex != that.multiIndex)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_start = true;
    builder.append(present_start);
    if (present_start)
      builder.append(start);

    boolean present_ending = true;
    builder.append(present_ending);
    if (present_ending)
      builder.append(ending);

    boolean present_label = true && (isSetLabel());
    builder.append(present_label);
    if (present_label)
      builder.append(label);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_attributes = true && (isSetAttributes());
    builder.append(present_attributes);
    if (present_attributes)
      builder.append(attributes);

    boolean present_multiIndex = true && (isSetMultiIndex());
    builder.append(present_multiIndex);
    if (present_multiIndex)
      builder.append(multiIndex);

    return builder.toHashCode();
  }

  public int compareTo(Span other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Span typedOther = (Span)other;

    lastComparison = Boolean.valueOf(isSetStart()).compareTo(typedOther.isSetStart());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetStart()) {      lastComparison = TBaseHelper.compareTo(this.start, typedOther.start);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetEnding()).compareTo(typedOther.isSetEnding());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetEnding()) {      lastComparison = TBaseHelper.compareTo(this.ending, typedOther.ending);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetLabel()).compareTo(typedOther.isSetLabel());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetLabel()) {      lastComparison = TBaseHelper.compareTo(this.label, typedOther.label);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetAttributes()).compareTo(typedOther.isSetAttributes());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAttributes()) {      lastComparison = TBaseHelper.compareTo(this.attributes, typedOther.attributes);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetMultiIndex()).compareTo(typedOther.isSetMultiIndex());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMultiIndex()) {      lastComparison = TBaseHelper.compareTo(this.multiIndex, typedOther.multiIndex);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // START
          if (field.type == TType.I32) {
            this.start = iprot.readI32();
            setStartIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // ENDING
          if (field.type == TType.I32) {
            this.ending = iprot.readI32();
            setEndingIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // LABEL
          if (field.type == TType.STRING) {
            this.label = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 6: // ATTRIBUTES
          if (field.type == TType.MAP) {
            {
              TMap _map0 = iprot.readMapBegin();
              this.attributes = new HashMap<String,String>(2*_map0.size);
              for (int _i1 = 0; _i1 < _map0.size; ++_i1)
              {
                String _key2;
                String _val3;
                _key2 = iprot.readString();
                _val3 = iprot.readString();
                this.attributes.put(_key2, _val3);
              }
              iprot.readMapEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 7: // MULTI_INDEX
          if (field.type == TType.I32) {
            this.multiIndex = iprot.readI32();
            setMultiIndexIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    if (!isSetStart()) {
      throw new TProtocolException("Required field 'start' was not found in serialized data! Struct: " + toString());
    }
    if (!isSetEnding()) {
      throw new TProtocolException("Required field 'ending' was not found in serialized data! Struct: " + toString());
    }
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(START_FIELD_DESC);
    oprot.writeI32(this.start);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(ENDING_FIELD_DESC);
    oprot.writeI32(this.ending);
    oprot.writeFieldEnd();
    if (this.label != null) {
      if (isSetLabel()) {
        oprot.writeFieldBegin(LABEL_FIELD_DESC);
        oprot.writeString(this.label);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (this.attributes != null) {
      if (isSetAttributes()) {
        oprot.writeFieldBegin(ATTRIBUTES_FIELD_DESC);
        {
          oprot.writeMapBegin(new TMap(TType.STRING, TType.STRING, this.attributes.size()));
          for (Map.Entry<String, String> _iter4 : this.attributes.entrySet())
          {
            oprot.writeString(_iter4.getKey());
            oprot.writeString(_iter4.getValue());
          }
          oprot.writeMapEnd();
        }
        oprot.writeFieldEnd();
      }
    }
    if (isSetMultiIndex()) {
      oprot.writeFieldBegin(MULTI_INDEX_FIELD_DESC);
      oprot.writeI32(this.multiIndex);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Span(");
    boolean first = true;

    sb.append("start:");
    sb.append(this.start);
    first = false;
    if (!first) sb.append(", ");
    sb.append("ending:");
    sb.append(this.ending);
    first = false;
    if (isSetLabel()) {
      if (!first) sb.append(", ");
      sb.append("label:");
      if (this.label == null) {
        sb.append("null");
      } else {
        sb.append(this.label);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetAttributes()) {
      if (!first) sb.append(", ");
      sb.append("attributes:");
      if (this.attributes == null) {
        sb.append("null");
      } else {
        sb.append(this.attributes);
      }
      first = false;
    }
    if (isSetMultiIndex()) {
      if (!first) sb.append(", ");
      sb.append("multiIndex:");
      sb.append(this.multiIndex);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    // alas, we cannot check 'start' because it's a primitive and you chose the non-beans generator.
    // alas, we cannot check 'ending' because it's a primitive and you chose the non-beans generator.
  }

}

