/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * Trees are a set of connected nodes with a top node.
 * 
 * <code>nodes</code> - the list of labeled nodes. <br/>
 * <code>top</code> - the index in nodes of the top node. <br/>
 * <code>source</code> - the source annotator this Tree came from.<br/>
 * <code>score</code> - the score for this Tree.
 */
public class Tree implements TBase<Tree, Tree._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("Tree");

  private static final TField NODES_FIELD_DESC = new TField("nodes", TType.LIST, (short)1);
  private static final TField TOP_FIELD_DESC = new TField("top", TType.I32, (short)2);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)3);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)4);

  /**
   * list of labeled nodes.
   */
  public List<Node> nodes;
  /**
   * the  index of top/root node in nodes.
   */
  public int top;
  /**
   * the source of this tree.
   */
  public String source;
  /**
   * the score of this tree.
   */
  public double score;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * list of labeled nodes.
     */
    NODES((short)1, "nodes"),
    /**
     * the  index of top/root node in nodes.
     */
    TOP((short)2, "top"),
    /**
     * the source of this tree.
     */
    SOURCE((short)3, "source"),
    /**
     * the score of this tree.
     */
    SCORE((short)4, "score");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // NODES
          return NODES;
        case 2: // TOP
          return TOP;
        case 3: // SOURCE
          return SOURCE;
        case 4: // SCORE
          return SCORE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __TOP_ISSET_ID = 0;
  private static final int __SCORE_ISSET_ID = 1;
  private BitSet __isset_bit_vector = new BitSet(2);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.NODES, new FieldMetaData("nodes", TFieldRequirementType.REQUIRED, 
        new ListMetaData(TType.LIST, 
            new StructMetaData(TType.STRUCT, Node.class))));
    tmpMap.put(_Fields.TOP, new FieldMetaData("top", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(Tree.class, metaDataMap);
  }

  public Tree() {
  }

  public Tree(
    List<Node> nodes,
    int top)
  {
    this();
    this.nodes = nodes;
    this.top = top;
    setTopIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Tree(Tree other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetNodes()) {
      List<Node> __this__nodes = new ArrayList<Node>();
      for (Node other_element : other.nodes) {
        __this__nodes.add(new Node(other_element));
      }
      this.nodes = __this__nodes;
    }
    this.top = other.top;
    if (other.isSetSource()) {
      this.source = other.source;
    }
    this.score = other.score;
  }

  public Tree deepCopy() {
    return new Tree(this);
  }

  @Deprecated
  public Tree clone() {
    return new Tree(this);
  }

  @Override
  public void clear() {
    this.nodes = null;
    setTopIsSet(false);
    this.top = 0;
    this.source = null;
    setScoreIsSet(false);
    this.score = 0.0;
  }

  public int getNodesSize() {
    return (this.nodes == null) ? 0 : this.nodes.size();
  }

  public java.util.Iterator<Node> getNodesIterator() {
    return (this.nodes == null) ? null : this.nodes.iterator();
  }

  public void addToNodes(Node elem) {
    if (this.nodes == null) {
      this.nodes = new ArrayList<Node>();
    }
    this.nodes.add(elem);
  }

  /**
   * list of labeled nodes.
   */
  public List<Node> getNodes() {
    return this.nodes;
  }

  /**
   * list of labeled nodes.
   */
  public Tree setNodes(List<Node> nodes) {
    this.nodes = nodes;
    return this;
  }

  public void unsetNodes() {
    this.nodes = null;
  }

  /** Returns true if field nodes is set (has been asigned a value) and false otherwise */
  public boolean isSetNodes() {
    return this.nodes != null;
  }

  public void setNodesIsSet(boolean value) {
    if (!value) {
      this.nodes = null;
    }
  }

  /**
   * the  index of top/root node in nodes.
   */
  public int getTop() {
    return this.top;
  }

  /**
   * the  index of top/root node in nodes.
   */
  public Tree setTop(int top) {
    this.top = top;
    setTopIsSet(true);
    return this;
  }

  public void unsetTop() {
    __isset_bit_vector.clear(__TOP_ISSET_ID);
  }

  /** Returns true if field top is set (has been asigned a value) and false otherwise */
  public boolean isSetTop() {
    return __isset_bit_vector.get(__TOP_ISSET_ID);
  }

  public void setTopIsSet(boolean value) {
    __isset_bit_vector.set(__TOP_ISSET_ID, value);
  }

  /**
   * the source of this tree.
   */
  public String getSource() {
    return this.source;
  }

  /**
   * the source of this tree.
   */
  public Tree setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  /**
   * the score of this tree.
   */
  public double getScore() {
    return this.score;
  }

  /**
   * the score of this tree.
   */
  public Tree setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case NODES:
      if (value == null) {
        unsetNodes();
      } else {
        setNodes((List<Node>)value);
      }
      break;

    case TOP:
      if (value == null) {
        unsetTop();
      } else {
        setTop((Integer)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case NODES:
      return getNodes();

    case TOP:
      return new Integer(getTop());

    case SOURCE:
      return getSource();

    case SCORE:
      return new Double(getScore());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case NODES:
      return isSetNodes();
    case TOP:
      return isSetTop();
    case SOURCE:
      return isSetSource();
    case SCORE:
      return isSetScore();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Tree)
      return this.equals((Tree)that);
    return false;
  }

  public boolean equals(Tree that) {
    if (that == null)
      return false;

    boolean this_present_nodes = true && this.isSetNodes();
    boolean that_present_nodes = true && that.isSetNodes();
    if (this_present_nodes || that_present_nodes) {
      if (!(this_present_nodes && that_present_nodes))
        return false;
      if (!this.nodes.equals(that.nodes))
        return false;
    }

    boolean this_present_top = true;
    boolean that_present_top = true;
    if (this_present_top || that_present_top) {
      if (!(this_present_top && that_present_top))
        return false;
      if (this.top != that.top)
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_nodes = true && (isSetNodes());
    builder.append(present_nodes);
    if (present_nodes)
      builder.append(nodes);

    boolean present_top = true;
    builder.append(present_top);
    if (present_top)
      builder.append(top);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    return builder.toHashCode();
  }

  public int compareTo(Tree other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Tree typedOther = (Tree)other;

    lastComparison = Boolean.valueOf(isSetNodes()).compareTo(typedOther.isSetNodes());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetNodes()) {      lastComparison = TBaseHelper.compareTo(this.nodes, typedOther.nodes);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetTop()).compareTo(typedOther.isSetTop());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTop()) {      lastComparison = TBaseHelper.compareTo(this.top, typedOther.top);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // NODES
          if (field.type == TType.LIST) {
            {
              TList _list18 = iprot.readListBegin();
              this.nodes = new ArrayList<Node>(_list18.size);
              for (int _i19 = 0; _i19 < _list18.size; ++_i19)
              {
                Node _elem20;
                _elem20 = new Node();
                _elem20.read(iprot);
                this.nodes.add(_elem20);
              }
              iprot.readListEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // TOP
          if (field.type == TType.I32) {
            this.top = iprot.readI32();
            setTopIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    if (!isSetTop()) {
      throw new TProtocolException("Required field 'top' was not found in serialized data! Struct: " + toString());
    }
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.nodes != null) {
      oprot.writeFieldBegin(NODES_FIELD_DESC);
      {
        oprot.writeListBegin(new TList(TType.STRUCT, this.nodes.size()));
        for (Node _iter21 : this.nodes)
        {
          _iter21.write(oprot);
        }
        oprot.writeListEnd();
      }
      oprot.writeFieldEnd();
    }
    oprot.writeFieldBegin(TOP_FIELD_DESC);
    oprot.writeI32(this.top);
    oprot.writeFieldEnd();
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("Tree(");
    boolean first = true;

    sb.append("nodes:");
    if (this.nodes == null) {
      sb.append("null");
    } else {
      sb.append(this.nodes);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("top:");
    sb.append(this.top);
    first = false;
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (nodes == null) {
      throw new TProtocolException("Required field 'nodes' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'top' because it's a primitive and you chose the non-beans generator.
  }

}

