/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.base;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

/**
 * A View is the most general data structure.  Spans and their relations.
 * 
 * <code>spans</code> - the spans of for this view.<br/>
 * <code>relations</code> - the relations of this view.<br/>
 * <code>source</code> - the source annotator this view came from.<br/>
 * <code>score</code> - the score for this view.<br/>
 * <code>rawText</code> - the raw text for this view (if null then consult the labeling's parent's rawText field, i.e., the Record's)
 */
public class View implements TBase<View, View._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("View");

  private static final TField SPANS_FIELD_DESC = new TField("spans", TType.LIST, (short)1);
  private static final TField RELATIONS_FIELD_DESC = new TField("relations", TType.LIST, (short)2);
  private static final TField RAW_TEXT_FIELD_DESC = new TField("rawText", TType.STRING, (short)3);
  private static final TField SOURCE_FIELD_DESC = new TField("source", TType.STRING, (short)4);
  private static final TField SCORE_FIELD_DESC = new TField("score", TType.DOUBLE, (short)5);

  public List<Span> spans;
  public List<Relation> relations;
  public String rawText;
  public String source;
  public double score;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    SPANS((short)1, "spans"),
    RELATIONS((short)2, "relations"),
    RAW_TEXT((short)3, "rawText"),
    SOURCE((short)4, "source"),
    SCORE((short)5, "score");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // SPANS
          return SPANS;
        case 2: // RELATIONS
          return RELATIONS;
        case 3: // RAW_TEXT
          return RAW_TEXT;
        case 4: // SOURCE
          return SOURCE;
        case 5: // SCORE
          return SCORE;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __SCORE_ISSET_ID = 0;
  private BitSet __isset_bit_vector = new BitSet(1);

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.SPANS, new FieldMetaData("spans", TFieldRequirementType.REQUIRED, 
        new ListMetaData(TType.LIST, 
            new StructMetaData(TType.STRUCT, Span.class))));
    tmpMap.put(_Fields.RELATIONS, new FieldMetaData("relations", TFieldRequirementType.REQUIRED, 
        new ListMetaData(TType.LIST, 
            new StructMetaData(TType.STRUCT, Relation.class))));
    tmpMap.put(_Fields.RAW_TEXT, new FieldMetaData("rawText", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.SOURCE, new FieldMetaData("source", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING        , "Source")));
    tmpMap.put(_Fields.SCORE, new FieldMetaData("score", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.DOUBLE)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(View.class, metaDataMap);
  }

  public View() {
  }

  public View(
    List<Span> spans,
    List<Relation> relations)
  {
    this();
    this.spans = spans;
    this.relations = relations;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public View(View other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetSpans()) {
      List<Span> __this__spans = new ArrayList<Span>();
      for (Span other_element : other.spans) {
        __this__spans.add(new Span(other_element));
      }
      this.spans = __this__spans;
    }
    if (other.isSetRelations()) {
      List<Relation> __this__relations = new ArrayList<Relation>();
      for (Relation other_element : other.relations) {
        __this__relations.add(new Relation(other_element));
      }
      this.relations = __this__relations;
    }
    if (other.isSetRawText()) {
      this.rawText = other.rawText;
    }
    if (other.isSetSource()) {
      this.source = other.source;
    }
    this.score = other.score;
  }

  public View deepCopy() {
    return new View(this);
  }

  @Deprecated
  public View clone() {
    return new View(this);
  }

  @Override
  public void clear() {
    this.spans = null;
    this.relations = null;
    this.rawText = null;
    this.source = null;
    setScoreIsSet(false);
    this.score = 0.0;
  }

  public int getSpansSize() {
    return (this.spans == null) ? 0 : this.spans.size();
  }

  public java.util.Iterator<Span> getSpansIterator() {
    return (this.spans == null) ? null : this.spans.iterator();
  }

  public void addToSpans(Span elem) {
    if (this.spans == null) {
      this.spans = new ArrayList<Span>();
    }
    this.spans.add(elem);
  }

  public List<Span> getSpans() {
    return this.spans;
  }

  public View setSpans(List<Span> spans) {
    this.spans = spans;
    return this;
  }

  public void unsetSpans() {
    this.spans = null;
  }

  /** Returns true if field spans is set (has been asigned a value) and false otherwise */
  public boolean isSetSpans() {
    return this.spans != null;
  }

  public void setSpansIsSet(boolean value) {
    if (!value) {
      this.spans = null;
    }
  }

  public int getRelationsSize() {
    return (this.relations == null) ? 0 : this.relations.size();
  }

  public java.util.Iterator<Relation> getRelationsIterator() {
    return (this.relations == null) ? null : this.relations.iterator();
  }

  public void addToRelations(Relation elem) {
    if (this.relations == null) {
      this.relations = new ArrayList<Relation>();
    }
    this.relations.add(elem);
  }

  public List<Relation> getRelations() {
    return this.relations;
  }

  public View setRelations(List<Relation> relations) {
    this.relations = relations;
    return this;
  }

  public void unsetRelations() {
    this.relations = null;
  }

  /** Returns true if field relations is set (has been asigned a value) and false otherwise */
  public boolean isSetRelations() {
    return this.relations != null;
  }

  public void setRelationsIsSet(boolean value) {
    if (!value) {
      this.relations = null;
    }
  }

  public String getRawText() {
    return this.rawText;
  }

  public View setRawText(String rawText) {
    this.rawText = rawText;
    return this;
  }

  public void unsetRawText() {
    this.rawText = null;
  }

  /** Returns true if field rawText is set (has been asigned a value) and false otherwise */
  public boolean isSetRawText() {
    return this.rawText != null;
  }

  public void setRawTextIsSet(boolean value) {
    if (!value) {
      this.rawText = null;
    }
  }

  public String getSource() {
    return this.source;
  }

  public View setSource(String source) {
    this.source = source;
    return this;
  }

  public void unsetSource() {
    this.source = null;
  }

  /** Returns true if field source is set (has been asigned a value) and false otherwise */
  public boolean isSetSource() {
    return this.source != null;
  }

  public void setSourceIsSet(boolean value) {
    if (!value) {
      this.source = null;
    }
  }

  public double getScore() {
    return this.score;
  }

  public View setScore(double score) {
    this.score = score;
    setScoreIsSet(true);
    return this;
  }

  public void unsetScore() {
    __isset_bit_vector.clear(__SCORE_ISSET_ID);
  }

  /** Returns true if field score is set (has been asigned a value) and false otherwise */
  public boolean isSetScore() {
    return __isset_bit_vector.get(__SCORE_ISSET_ID);
  }

  public void setScoreIsSet(boolean value) {
    __isset_bit_vector.set(__SCORE_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case SPANS:
      if (value == null) {
        unsetSpans();
      } else {
        setSpans((List<Span>)value);
      }
      break;

    case RELATIONS:
      if (value == null) {
        unsetRelations();
      } else {
        setRelations((List<Relation>)value);
      }
      break;

    case RAW_TEXT:
      if (value == null) {
        unsetRawText();
      } else {
        setRawText((String)value);
      }
      break;

    case SOURCE:
      if (value == null) {
        unsetSource();
      } else {
        setSource((String)value);
      }
      break;

    case SCORE:
      if (value == null) {
        unsetScore();
      } else {
        setScore((Double)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case SPANS:
      return getSpans();

    case RELATIONS:
      return getRelations();

    case RAW_TEXT:
      return getRawText();

    case SOURCE:
      return getSource();

    case SCORE:
      return new Double(getScore());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case SPANS:
      return isSetSpans();
    case RELATIONS:
      return isSetRelations();
    case RAW_TEXT:
      return isSetRawText();
    case SOURCE:
      return isSetSource();
    case SCORE:
      return isSetScore();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof View)
      return this.equals((View)that);
    return false;
  }

  public boolean equals(View that) {
    if (that == null)
      return false;

    boolean this_present_spans = true && this.isSetSpans();
    boolean that_present_spans = true && that.isSetSpans();
    if (this_present_spans || that_present_spans) {
      if (!(this_present_spans && that_present_spans))
        return false;
      if (!this.spans.equals(that.spans))
        return false;
    }

    boolean this_present_relations = true && this.isSetRelations();
    boolean that_present_relations = true && that.isSetRelations();
    if (this_present_relations || that_present_relations) {
      if (!(this_present_relations && that_present_relations))
        return false;
      if (!this.relations.equals(that.relations))
        return false;
    }

    boolean this_present_rawText = true && this.isSetRawText();
    boolean that_present_rawText = true && that.isSetRawText();
    if (this_present_rawText || that_present_rawText) {
      if (!(this_present_rawText && that_present_rawText))
        return false;
      if (!this.rawText.equals(that.rawText))
        return false;
    }

    boolean this_present_source = true && this.isSetSource();
    boolean that_present_source = true && that.isSetSource();
    if (this_present_source || that_present_source) {
      if (!(this_present_source && that_present_source))
        return false;
      if (!this.source.equals(that.source))
        return false;
    }

    boolean this_present_score = true && this.isSetScore();
    boolean that_present_score = true && that.isSetScore();
    if (this_present_score || that_present_score) {
      if (!(this_present_score && that_present_score))
        return false;
      if (this.score != that.score)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    HashCodeBuilder builder = new HashCodeBuilder();

    boolean present_spans = true && (isSetSpans());
    builder.append(present_spans);
    if (present_spans)
      builder.append(spans);

    boolean present_relations = true && (isSetRelations());
    builder.append(present_relations);
    if (present_relations)
      builder.append(relations);

    boolean present_rawText = true && (isSetRawText());
    builder.append(present_rawText);
    if (present_rawText)
      builder.append(rawText);

    boolean present_source = true && (isSetSource());
    builder.append(present_source);
    if (present_source)
      builder.append(source);

    boolean present_score = true && (isSetScore());
    builder.append(present_score);
    if (present_score)
      builder.append(score);

    return builder.toHashCode();
  }

  public int compareTo(View other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    View typedOther = (View)other;

    lastComparison = Boolean.valueOf(isSetSpans()).compareTo(typedOther.isSetSpans());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSpans()) {      lastComparison = TBaseHelper.compareTo(this.spans, typedOther.spans);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRelations()).compareTo(typedOther.isSetRelations());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRelations()) {      lastComparison = TBaseHelper.compareTo(this.relations, typedOther.relations);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRawText()).compareTo(typedOther.isSetRawText());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRawText()) {      lastComparison = TBaseHelper.compareTo(this.rawText, typedOther.rawText);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSource()).compareTo(typedOther.isSetSource());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSource()) {      lastComparison = TBaseHelper.compareTo(this.source, typedOther.source);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetScore()).compareTo(typedOther.isSetScore());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetScore()) {      lastComparison = TBaseHelper.compareTo(this.score, typedOther.score);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // SPANS
          if (field.type == TType.LIST) {
            {
              TList _list26 = iprot.readListBegin();
              this.spans = new ArrayList<Span>(_list26.size);
              for (int _i27 = 0; _i27 < _list26.size; ++_i27)
              {
                Span _elem28;
                _elem28 = new Span();
                _elem28.read(iprot);
                this.spans.add(_elem28);
              }
              iprot.readListEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // RELATIONS
          if (field.type == TType.LIST) {
            {
              TList _list29 = iprot.readListBegin();
              this.relations = new ArrayList<Relation>(_list29.size);
              for (int _i30 = 0; _i30 < _list29.size; ++_i30)
              {
                Relation _elem31;
                _elem31 = new Relation();
                _elem31.read(iprot);
                this.relations.add(_elem31);
              }
              iprot.readListEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // RAW_TEXT
          if (field.type == TType.STRING) {
            this.rawText = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // SOURCE
          if (field.type == TType.STRING) {
            this.source = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // SCORE
          if (field.type == TType.DOUBLE) {
            this.score = iprot.readDouble();
            setScoreIsSet(true);
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();

    // check for required fields of primitive type, which can't be checked in the validate method
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.spans != null) {
      oprot.writeFieldBegin(SPANS_FIELD_DESC);
      {
        oprot.writeListBegin(new TList(TType.STRUCT, this.spans.size()));
        for (Span _iter32 : this.spans)
        {
          _iter32.write(oprot);
        }
        oprot.writeListEnd();
      }
      oprot.writeFieldEnd();
    }
    if (this.relations != null) {
      oprot.writeFieldBegin(RELATIONS_FIELD_DESC);
      {
        oprot.writeListBegin(new TList(TType.STRUCT, this.relations.size()));
        for (Relation _iter33 : this.relations)
        {
          _iter33.write(oprot);
        }
        oprot.writeListEnd();
      }
      oprot.writeFieldEnd();
    }
    if (this.rawText != null) {
      if (isSetRawText()) {
        oprot.writeFieldBegin(RAW_TEXT_FIELD_DESC);
        oprot.writeString(this.rawText);
        oprot.writeFieldEnd();
      }
    }
    if (this.source != null) {
      if (isSetSource()) {
        oprot.writeFieldBegin(SOURCE_FIELD_DESC);
        oprot.writeString(this.source);
        oprot.writeFieldEnd();
      }
    }
    if (isSetScore()) {
      oprot.writeFieldBegin(SCORE_FIELD_DESC);
      oprot.writeDouble(this.score);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("View(");
    boolean first = true;

    sb.append("spans:");
    if (this.spans == null) {
      sb.append("null");
    } else {
      sb.append(this.spans);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("relations:");
    if (this.relations == null) {
      sb.append("null");
    } else {
      sb.append(this.relations);
    }
    first = false;
    if (isSetRawText()) {
      if (!first) sb.append(", ");
      sb.append("rawText:");
      if (this.rawText == null) {
        sb.append("null");
      } else {
        sb.append(this.rawText);
      }
      first = false;
    }
    if (isSetSource()) {
      if (!first) sb.append(", ");
      sb.append("source:");
      if (this.source == null) {
        sb.append("null");
      } else {
        sb.append(this.source);
      }
      first = false;
    }
    if (isSetScore()) {
      if (!first) sb.append(", ");
      sb.append("score:");
      sb.append(this.score);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (spans == null) {
      throw new TProtocolException("Required field 'spans' was not present! Struct: " + toString());
    }
    if (relations == null) {
      throw new TProtocolException("Required field 'relations' was not present! Struct: " + toString());
    }
  }

}

