/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package edu.illinois.cs.cogcomp.thrift.curator;

import org.apache.commons.lang.builder.HashCodeBuilder;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

public class Curator {

  public interface Iface extends edu.illinois.cs.cogcomp.thrift.base.BaseService.Iface {

    /**
     * Returns a map of view_names to annotation server names. Useful for
     * inspecting the annotations available via the curator.
     */
    public Map<String,String> describeAnnotations() throws TException;

    /**
     * Is caching enabled on this server?
     */
    public boolean isCacheAvailable() throws TException;

    /**
     * Provide annotation of view_name for a given text. forceUpdate forces the
     * annotation to be reprocessed even if it is available in the cache.
     * 
     * @param view_name
     * @param text
     * @param forceUpdate
     */
    public Record provide(String view_name, String text, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Provide annotation of view_name for a given list of strings.  Each string
     * will be tokenized on whitespace and each string should represent one
     * sentence. forceUpdate forces the annotation to be reprocessed even if it is
     * available in the cache.
     * 
     * @param view_name
     * @param sentences
     * @param forceUpdate
     */
    public Record wsprovide(String view_name, List<String> sentences, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Annotates the given Record (by modifying the Record itself) with the
     * requested view.
     * @param record The record to which an annotation should be added
     * @param view_name The type of annotation to be performed on the record
     * @TODO: Test this!
     * 
     * @param record
     * @param view_name
     * @param forceUpdate
     */
    public void performAnnotation(Record record, String view_name, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Returns the Record for a given text.
     * 
     * @param text
     */
    public Record getRecord(String text) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Returns the Record for a given list of strings. Each string will be
     * tokenized on whitespace and each string should represent one sentence.
     * 
     * @param sentences
     */
    public Record wsgetRecord(List<String> sentences) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Returns the Record associated with a given identifier.
     * 
     * @param identifier
     */
    public Record getRecordById(String identifier) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Store the given Record.  Usually disabled.
     * 
     * @param record
     */
    public void storeRecord(Record record) throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException;

    /**
     * Returns a MultiRecord for a given list of texts.
     * 
     * @param texts
     */
    public MultiRecord getMultiRecord(List<String> texts) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Provides the view_name for multiple texts in a MultiRecord.
     * 
     * @param view_name
     * @param texts
     * @param forceUpdate
     */
    public MultiRecord provideMulti(String view_name, List<String> texts, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException;

    /**
     * Store the given MultiRecord.  Usually disabled.
     * 
     * @param record
     */
    public void storeMultiRecord(MultiRecord record) throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException;

  }

  public interface AsyncIface extends edu.illinois.cs.cogcomp.thrift.base.BaseService .AsyncIface {

    public void describeAnnotations(AsyncMethodCallback<AsyncClient.describeAnnotations_call> resultHandler) throws TException;

    public void isCacheAvailable(AsyncMethodCallback<AsyncClient.isCacheAvailable_call> resultHandler) throws TException;

    public void provide(String view_name, String text, boolean forceUpdate, AsyncMethodCallback<AsyncClient.provide_call> resultHandler) throws TException;

    public void wsprovide(String view_name, List<String> sentences, boolean forceUpdate, AsyncMethodCallback<AsyncClient.wsprovide_call> resultHandler) throws TException;

    public void performAnnotation(Record record, String view_name, boolean forceUpdate, AsyncMethodCallback<AsyncClient.performAnnotation_call> resultHandler) throws TException;

    public void getRecord(String text, AsyncMethodCallback<AsyncClient.getRecord_call> resultHandler) throws TException;

    public void wsgetRecord(List<String> sentences, AsyncMethodCallback<AsyncClient.wsgetRecord_call> resultHandler) throws TException;

    public void getRecordById(String identifier, AsyncMethodCallback<AsyncClient.getRecordById_call> resultHandler) throws TException;

    public void storeRecord(Record record, AsyncMethodCallback<AsyncClient.storeRecord_call> resultHandler) throws TException;

    public void getMultiRecord(List<String> texts, AsyncMethodCallback<AsyncClient.getMultiRecord_call> resultHandler) throws TException;

    public void provideMulti(String view_name, List<String> texts, boolean forceUpdate, AsyncMethodCallback<AsyncClient.provideMulti_call> resultHandler) throws TException;

    public void storeMultiRecord(MultiRecord record, AsyncMethodCallback<AsyncClient.storeMultiRecord_call> resultHandler) throws TException;

  }

  public static class Client extends edu.illinois.cs.cogcomp.thrift.base.BaseService.Client implements TServiceClient, Iface {
    public static class Factory implements TServiceClientFactory<Client> {
      public Factory() {}
      public Client getClient(TProtocol prot) {
        return new Client(prot);
      }
      public Client getClient(TProtocol iprot, TProtocol oprot) {
        return new Client(iprot, oprot);
      }
    }

    public Client(TProtocol prot)
    {
      this(prot, prot);
    }

    public Client(TProtocol iprot, TProtocol oprot)
    {
      super(iprot, oprot);
    }

    public Map<String,String> describeAnnotations() throws TException
    {
      send_describeAnnotations();
      return recv_describeAnnotations();
    }

    public void send_describeAnnotations() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("describeAnnotations", TMessageType.CALL, ++seqid_));
      describeAnnotations_args args = new describeAnnotations_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Map<String,String> recv_describeAnnotations() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "describeAnnotations failed: out of sequence response");
      }
      describeAnnotations_result result = new describeAnnotations_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "describeAnnotations failed: unknown result");
    }

    public boolean isCacheAvailable() throws TException
    {
      send_isCacheAvailable();
      return recv_isCacheAvailable();
    }

    public void send_isCacheAvailable() throws TException
    {
      oprot_.writeMessageBegin(new TMessage("isCacheAvailable", TMessageType.CALL, ++seqid_));
      isCacheAvailable_args args = new isCacheAvailable_args();
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public boolean recv_isCacheAvailable() throws TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "isCacheAvailable failed: out of sequence response");
      }
      isCacheAvailable_result result = new isCacheAvailable_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "isCacheAvailable failed: unknown result");
    }

    public Record provide(String view_name, String text, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_provide(view_name, text, forceUpdate);
      return recv_provide();
    }

    public void send_provide(String view_name, String text, boolean forceUpdate) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("provide", TMessageType.CALL, ++seqid_));
      provide_args args = new provide_args();
      args.setView_name(view_name);
      args.setText(text);
      args.setForceUpdate(forceUpdate);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Record recv_provide() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "provide failed: out of sequence response");
      }
      provide_result result = new provide_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.suex != null) {
        throw result.suex;
      }
      if (result.afex != null) {
        throw result.afex;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "provide failed: unknown result");
    }

    public Record wsprovide(String view_name, List<String> sentences, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_wsprovide(view_name, sentences, forceUpdate);
      return recv_wsprovide();
    }

    public void send_wsprovide(String view_name, List<String> sentences, boolean forceUpdate) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("wsprovide", TMessageType.CALL, ++seqid_));
      wsprovide_args args = new wsprovide_args();
      args.setView_name(view_name);
      args.setSentences(sentences);
      args.setForceUpdate(forceUpdate);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Record recv_wsprovide() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "wsprovide failed: out of sequence response");
      }
      wsprovide_result result = new wsprovide_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.suex != null) {
        throw result.suex;
      }
      if (result.afex != null) {
        throw result.afex;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "wsprovide failed: unknown result");
    }

    public void performAnnotation(Record record, String view_name, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_performAnnotation(record, view_name, forceUpdate);
      recv_performAnnotation();
    }

    public void send_performAnnotation(Record record, String view_name, boolean forceUpdate) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("performAnnotation", TMessageType.CALL, ++seqid_));
      performAnnotation_args args = new performAnnotation_args();
      args.setRecord(record);
      args.setView_name(view_name);
      args.setForceUpdate(forceUpdate);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_performAnnotation() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "performAnnotation failed: out of sequence response");
      }
      performAnnotation_result result = new performAnnotation_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.suex != null) {
        throw result.suex;
      }
      if (result.afex != null) {
        throw result.afex;
      }
      return;
    }

    public Record getRecord(String text) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_getRecord(text);
      return recv_getRecord();
    }

    public void send_getRecord(String text) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getRecord", TMessageType.CALL, ++seqid_));
      getRecord_args args = new getRecord_args();
      args.setText(text);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Record recv_getRecord() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "getRecord failed: out of sequence response");
      }
      getRecord_result result = new getRecord_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.ex != null) {
        throw result.ex;
      }
      if (result.ex2 != null) {
        throw result.ex2;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getRecord failed: unknown result");
    }

    public Record wsgetRecord(List<String> sentences) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_wsgetRecord(sentences);
      return recv_wsgetRecord();
    }

    public void send_wsgetRecord(List<String> sentences) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("wsgetRecord", TMessageType.CALL, ++seqid_));
      wsgetRecord_args args = new wsgetRecord_args();
      args.setSentences(sentences);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Record recv_wsgetRecord() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "wsgetRecord failed: out of sequence response");
      }
      wsgetRecord_result result = new wsgetRecord_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.ex != null) {
        throw result.ex;
      }
      if (result.ex2 != null) {
        throw result.ex2;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "wsgetRecord failed: unknown result");
    }

    public Record getRecordById(String identifier) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_getRecordById(identifier);
      return recv_getRecordById();
    }

    public void send_getRecordById(String identifier) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getRecordById", TMessageType.CALL, ++seqid_));
      getRecordById_args args = new getRecordById_args();
      args.setIdentifier(identifier);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public Record recv_getRecordById() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "getRecordById failed: out of sequence response");
      }
      getRecordById_result result = new getRecordById_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.ex != null) {
        throw result.ex;
      }
      if (result.ex2 != null) {
        throw result.ex2;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getRecordById failed: unknown result");
    }

    public void storeRecord(Record record) throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException
    {
      send_storeRecord(record);
      recv_storeRecord();
    }

    public void send_storeRecord(Record record) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("storeRecord", TMessageType.CALL, ++seqid_));
      storeRecord_args args = new storeRecord_args();
      args.setRecord(record);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_storeRecord() throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "storeRecord failed: out of sequence response");
      }
      storeRecord_result result = new storeRecord_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.ssex != null) {
        throw result.ssex;
      }
      return;
    }

    public MultiRecord getMultiRecord(List<String> texts) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_getMultiRecord(texts);
      return recv_getMultiRecord();
    }

    public void send_getMultiRecord(List<String> texts) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("getMultiRecord", TMessageType.CALL, ++seqid_));
      getMultiRecord_args args = new getMultiRecord_args();
      args.setTexts(texts);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public MultiRecord recv_getMultiRecord() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "getMultiRecord failed: out of sequence response");
      }
      getMultiRecord_result result = new getMultiRecord_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.ex != null) {
        throw result.ex;
      }
      if (result.ex2 != null) {
        throw result.ex2;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "getMultiRecord failed: unknown result");
    }

    public MultiRecord provideMulti(String view_name, List<String> texts, boolean forceUpdate) throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      send_provideMulti(view_name, texts, forceUpdate);
      return recv_provideMulti();
    }

    public void send_provideMulti(String view_name, List<String> texts, boolean forceUpdate) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("provideMulti", TMessageType.CALL, ++seqid_));
      provideMulti_args args = new provideMulti_args();
      args.setView_name(view_name);
      args.setTexts(texts);
      args.setForceUpdate(forceUpdate);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public MultiRecord recv_provideMulti() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "provideMulti failed: out of sequence response");
      }
      provideMulti_result result = new provideMulti_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.isSetSuccess()) {
        return result.success;
      }
      if (result.suex != null) {
        throw result.suex;
      }
      if (result.afex != null) {
        throw result.afex;
      }
      throw new TApplicationException(TApplicationException.MISSING_RESULT, "provideMulti failed: unknown result");
    }

    public void storeMultiRecord(MultiRecord record) throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException
    {
      send_storeMultiRecord(record);
      recv_storeMultiRecord();
    }

    public void send_storeMultiRecord(MultiRecord record) throws TException
    {
      oprot_.writeMessageBegin(new TMessage("storeMultiRecord", TMessageType.CALL, ++seqid_));
      storeMultiRecord_args args = new storeMultiRecord_args();
      args.setRecord(record);
      args.write(oprot_);
      oprot_.writeMessageEnd();
      oprot_.getTransport().flush();
    }

    public void recv_storeMultiRecord() throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException
    {
      TMessage msg = iprot_.readMessageBegin();
      if (msg.type == TMessageType.EXCEPTION) {
        TApplicationException x = TApplicationException.read(iprot_);
        iprot_.readMessageEnd();
        throw x;
      }
      if (msg.seqid != seqid_) {
        throw new TApplicationException(TApplicationException.BAD_SEQUENCE_ID, "storeMultiRecord failed: out of sequence response");
      }
      storeMultiRecord_result result = new storeMultiRecord_result();
      result.read(iprot_);
      iprot_.readMessageEnd();
      if (result.ssex != null) {
        throw result.ssex;
      }
      return;
    }

  }
  public static class AsyncClient extends edu.illinois.cs.cogcomp.thrift.base.BaseService.AsyncClient implements AsyncIface {
    public static class Factory implements TAsyncClientFactory<AsyncClient> {
      private TAsyncClientManager clientManager;
      private TProtocolFactory protocolFactory;
      public Factory(TAsyncClientManager clientManager, TProtocolFactory protocolFactory) {
        this.clientManager = clientManager;
        this.protocolFactory = protocolFactory;
      }
      public AsyncClient getAsyncClient(TNonblockingTransport transport) {
        return new AsyncClient(protocolFactory, clientManager, transport);
      }
    }

    public AsyncClient(TProtocolFactory protocolFactory, TAsyncClientManager clientManager, TNonblockingTransport transport) {
      super(protocolFactory, clientManager, transport);
    }

    public void describeAnnotations(AsyncMethodCallback<describeAnnotations_call> resultHandler) throws TException {
      checkReady();
      describeAnnotations_call method_call = new describeAnnotations_call(resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class describeAnnotations_call extends TAsyncMethodCall {
      public describeAnnotations_call(AsyncMethodCallback<describeAnnotations_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("describeAnnotations", TMessageType.CALL, 0));
        describeAnnotations_args args = new describeAnnotations_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Map<String,String> getResult() throws TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_describeAnnotations();
      }
    }

    public void isCacheAvailable(AsyncMethodCallback<isCacheAvailable_call> resultHandler) throws TException {
      checkReady();
      isCacheAvailable_call method_call = new isCacheAvailable_call(resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class isCacheAvailable_call extends TAsyncMethodCall {
      public isCacheAvailable_call(AsyncMethodCallback<isCacheAvailable_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("isCacheAvailable", TMessageType.CALL, 0));
        isCacheAvailable_args args = new isCacheAvailable_args();
        args.write(prot);
        prot.writeMessageEnd();
      }

      public boolean getResult() throws TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_isCacheAvailable();
      }
    }

    public void provide(String view_name, String text, boolean forceUpdate, AsyncMethodCallback<provide_call> resultHandler) throws TException {
      checkReady();
      provide_call method_call = new provide_call(view_name, text, forceUpdate, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class provide_call extends TAsyncMethodCall {
      private String view_name;
      private String text;
      private boolean forceUpdate;
      public provide_call(String view_name, String text, boolean forceUpdate, AsyncMethodCallback<provide_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.view_name = view_name;
        this.text = text;
        this.forceUpdate = forceUpdate;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("provide", TMessageType.CALL, 0));
        provide_args args = new provide_args();
        args.setView_name(view_name);
        args.setText(text);
        args.setForceUpdate(forceUpdate);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Record getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_provide();
      }
    }

    public void wsprovide(String view_name, List<String> sentences, boolean forceUpdate, AsyncMethodCallback<wsprovide_call> resultHandler) throws TException {
      checkReady();
      wsprovide_call method_call = new wsprovide_call(view_name, sentences, forceUpdate, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class wsprovide_call extends TAsyncMethodCall {
      private String view_name;
      private List<String> sentences;
      private boolean forceUpdate;
      public wsprovide_call(String view_name, List<String> sentences, boolean forceUpdate, AsyncMethodCallback<wsprovide_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.view_name = view_name;
        this.sentences = sentences;
        this.forceUpdate = forceUpdate;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("wsprovide", TMessageType.CALL, 0));
        wsprovide_args args = new wsprovide_args();
        args.setView_name(view_name);
        args.setSentences(sentences);
        args.setForceUpdate(forceUpdate);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Record getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_wsprovide();
      }
    }

    public void performAnnotation(Record record, String view_name, boolean forceUpdate, AsyncMethodCallback<performAnnotation_call> resultHandler) throws TException {
      checkReady();
      performAnnotation_call method_call = new performAnnotation_call(record, view_name, forceUpdate, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class performAnnotation_call extends TAsyncMethodCall {
      private Record record;
      private String view_name;
      private boolean forceUpdate;
      public performAnnotation_call(Record record, String view_name, boolean forceUpdate, AsyncMethodCallback<performAnnotation_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.record = record;
        this.view_name = view_name;
        this.forceUpdate = forceUpdate;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("performAnnotation", TMessageType.CALL, 0));
        performAnnotation_args args = new performAnnotation_args();
        args.setRecord(record);
        args.setView_name(view_name);
        args.setForceUpdate(forceUpdate);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        (new Client(prot)).recv_performAnnotation();
      }
    }

    public void getRecord(String text, AsyncMethodCallback<getRecord_call> resultHandler) throws TException {
      checkReady();
      getRecord_call method_call = new getRecord_call(text, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class getRecord_call extends TAsyncMethodCall {
      private String text;
      public getRecord_call(String text, AsyncMethodCallback<getRecord_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.text = text;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("getRecord", TMessageType.CALL, 0));
        getRecord_args args = new getRecord_args();
        args.setText(text);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Record getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getRecord();
      }
    }

    public void wsgetRecord(List<String> sentences, AsyncMethodCallback<wsgetRecord_call> resultHandler) throws TException {
      checkReady();
      wsgetRecord_call method_call = new wsgetRecord_call(sentences, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class wsgetRecord_call extends TAsyncMethodCall {
      private List<String> sentences;
      public wsgetRecord_call(List<String> sentences, AsyncMethodCallback<wsgetRecord_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.sentences = sentences;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("wsgetRecord", TMessageType.CALL, 0));
        wsgetRecord_args args = new wsgetRecord_args();
        args.setSentences(sentences);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Record getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_wsgetRecord();
      }
    }

    public void getRecordById(String identifier, AsyncMethodCallback<getRecordById_call> resultHandler) throws TException {
      checkReady();
      getRecordById_call method_call = new getRecordById_call(identifier, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class getRecordById_call extends TAsyncMethodCall {
      private String identifier;
      public getRecordById_call(String identifier, AsyncMethodCallback<getRecordById_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.identifier = identifier;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("getRecordById", TMessageType.CALL, 0));
        getRecordById_args args = new getRecordById_args();
        args.setIdentifier(identifier);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public Record getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getRecordById();
      }
    }

    public void storeRecord(Record record, AsyncMethodCallback<storeRecord_call> resultHandler) throws TException {
      checkReady();
      storeRecord_call method_call = new storeRecord_call(record, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class storeRecord_call extends TAsyncMethodCall {
      private Record record;
      public storeRecord_call(Record record, AsyncMethodCallback<storeRecord_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.record = record;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("storeRecord", TMessageType.CALL, 0));
        storeRecord_args args = new storeRecord_args();
        args.setRecord(record);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        (new Client(prot)).recv_storeRecord();
      }
    }

    public void getMultiRecord(List<String> texts, AsyncMethodCallback<getMultiRecord_call> resultHandler) throws TException {
      checkReady();
      getMultiRecord_call method_call = new getMultiRecord_call(texts, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class getMultiRecord_call extends TAsyncMethodCall {
      private List<String> texts;
      public getMultiRecord_call(List<String> texts, AsyncMethodCallback<getMultiRecord_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.texts = texts;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("getMultiRecord", TMessageType.CALL, 0));
        getMultiRecord_args args = new getMultiRecord_args();
        args.setTexts(texts);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public MultiRecord getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_getMultiRecord();
      }
    }

    public void provideMulti(String view_name, List<String> texts, boolean forceUpdate, AsyncMethodCallback<provideMulti_call> resultHandler) throws TException {
      checkReady();
      provideMulti_call method_call = new provideMulti_call(view_name, texts, forceUpdate, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class provideMulti_call extends TAsyncMethodCall {
      private String view_name;
      private List<String> texts;
      private boolean forceUpdate;
      public provideMulti_call(String view_name, List<String> texts, boolean forceUpdate, AsyncMethodCallback<provideMulti_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.view_name = view_name;
        this.texts = texts;
        this.forceUpdate = forceUpdate;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("provideMulti", TMessageType.CALL, 0));
        provideMulti_args args = new provideMulti_args();
        args.setView_name(view_name);
        args.setTexts(texts);
        args.setForceUpdate(forceUpdate);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public MultiRecord getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException, edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        return (new Client(prot)).recv_provideMulti();
      }
    }

    public void storeMultiRecord(MultiRecord record, AsyncMethodCallback<storeMultiRecord_call> resultHandler) throws TException {
      checkReady();
      storeMultiRecord_call method_call = new storeMultiRecord_call(record, resultHandler, this, protocolFactory, transport);
      manager.call(method_call);
    }

    public static class storeMultiRecord_call extends TAsyncMethodCall {
      private MultiRecord record;
      public storeMultiRecord_call(MultiRecord record, AsyncMethodCallback<storeMultiRecord_call> resultHandler, TAsyncClient client, TProtocolFactory protocolFactory, TNonblockingTransport transport) throws TException {
        super(client, protocolFactory, transport, resultHandler, false);
        this.record = record;
      }

      public void write_args(TProtocol prot) throws TException {
        prot.writeMessageBegin(new TMessage("storeMultiRecord", TMessageType.CALL, 0));
        storeMultiRecord_args args = new storeMultiRecord_args();
        args.setRecord(record);
        args.write(prot);
        prot.writeMessageEnd();
      }

      public void getResult() throws edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException, TException {
        if (getState() != State.RESPONSE_READ) {
          throw new IllegalStateException("Method call not finished!");
        }
        TMemoryInputTransport memoryTransport = new TMemoryInputTransport(getFrameBuffer().array());
        TProtocol prot = client.getProtocolFactory().getProtocol(memoryTransport);
        (new Client(prot)).recv_storeMultiRecord();
      }
    }

  }

  public static class Processor extends edu.illinois.cs.cogcomp.thrift.base.BaseService.Processor implements TProcessor {
    private static final Logger LOGGER = LoggerFactory.getLogger(Processor.class.getName());
    public Processor(Iface iface)
    {
      super(iface);
      iface_ = iface;
      processMap_.put("describeAnnotations", new describeAnnotations());
      processMap_.put("isCacheAvailable", new isCacheAvailable());
      processMap_.put("provide", new provide());
      processMap_.put("wsprovide", new wsprovide());
      processMap_.put("performAnnotation", new performAnnotation());
      processMap_.put("getRecord", new getRecord());
      processMap_.put("wsgetRecord", new wsgetRecord());
      processMap_.put("getRecordById", new getRecordById());
      processMap_.put("storeRecord", new storeRecord());
      processMap_.put("getMultiRecord", new getMultiRecord());
      processMap_.put("provideMulti", new provideMulti());
      processMap_.put("storeMultiRecord", new storeMultiRecord());
    }

    private Iface iface_;

    public boolean process(TProtocol iprot, TProtocol oprot) throws TException
    {
      TMessage msg = iprot.readMessageBegin();
      ProcessFunction fn = processMap_.get(msg.name);
      if (fn == null) {
        TProtocolUtil.skip(iprot, TType.STRUCT);
        iprot.readMessageEnd();
        TApplicationException x = new TApplicationException(TApplicationException.UNKNOWN_METHOD, "Invalid method name: '"+msg.name+"'");
        oprot.writeMessageBegin(new TMessage(msg.name, TMessageType.EXCEPTION, msg.seqid));
        x.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
        return true;
      }
      fn.process(msg.seqid, iprot, oprot);
      return true;
    }

    private class describeAnnotations implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        describeAnnotations_args args = new describeAnnotations_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("describeAnnotations", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        describeAnnotations_result result = new describeAnnotations_result();
        result.success = iface_.describeAnnotations();
        oprot.writeMessageBegin(new TMessage("describeAnnotations", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class isCacheAvailable implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        isCacheAvailable_args args = new isCacheAvailable_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("isCacheAvailable", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        isCacheAvailable_result result = new isCacheAvailable_result();
        result.success = iface_.isCacheAvailable();
        result.setSuccessIsSet(true);
        oprot.writeMessageBegin(new TMessage("isCacheAvailable", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class provide implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        provide_args args = new provide_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("provide", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        provide_result result = new provide_result();
        try {
          result.success = iface_.provide(args.view_name, args.text, args.forceUpdate);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
          result.suex = suex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
          result.afex = afex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing provide", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing provide");
          oprot.writeMessageBegin(new TMessage("provide", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("provide", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class wsprovide implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        wsprovide_args args = new wsprovide_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("wsprovide", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        wsprovide_result result = new wsprovide_result();
        try {
          result.success = iface_.wsprovide(args.view_name, args.sentences, args.forceUpdate);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
          result.suex = suex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
          result.afex = afex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing wsprovide", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing wsprovide");
          oprot.writeMessageBegin(new TMessage("wsprovide", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("wsprovide", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class performAnnotation implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        performAnnotation_args args = new performAnnotation_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("performAnnotation", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        performAnnotation_result result = new performAnnotation_result();
        try {
          iface_.performAnnotation(args.record, args.view_name, args.forceUpdate);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
          result.suex = suex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
          result.afex = afex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing performAnnotation", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing performAnnotation");
          oprot.writeMessageBegin(new TMessage("performAnnotation", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("performAnnotation", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getRecord implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getRecord_args args = new getRecord_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("getRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        getRecord_result result = new getRecord_result();
        try {
          result.success = iface_.getRecord(args.text);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
          result.ex = ex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
          result.ex2 = ex2;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing getRecord", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing getRecord");
          oprot.writeMessageBegin(new TMessage("getRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("getRecord", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class wsgetRecord implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        wsgetRecord_args args = new wsgetRecord_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("wsgetRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        wsgetRecord_result result = new wsgetRecord_result();
        try {
          result.success = iface_.wsgetRecord(args.sentences);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
          result.ex = ex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
          result.ex2 = ex2;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing wsgetRecord", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing wsgetRecord");
          oprot.writeMessageBegin(new TMessage("wsgetRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("wsgetRecord", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getRecordById implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getRecordById_args args = new getRecordById_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("getRecordById", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        getRecordById_result result = new getRecordById_result();
        try {
          result.success = iface_.getRecordById(args.identifier);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
          result.ex = ex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
          result.ex2 = ex2;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing getRecordById", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing getRecordById");
          oprot.writeMessageBegin(new TMessage("getRecordById", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("getRecordById", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class storeRecord implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        storeRecord_args args = new storeRecord_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("storeRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        storeRecord_result result = new storeRecord_result();
        try {
          iface_.storeRecord(args.record);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex) {
          result.ssex = ssex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing storeRecord", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing storeRecord");
          oprot.writeMessageBegin(new TMessage("storeRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("storeRecord", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class getMultiRecord implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        getMultiRecord_args args = new getMultiRecord_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("getMultiRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        getMultiRecord_result result = new getMultiRecord_result();
        try {
          result.success = iface_.getMultiRecord(args.texts);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
          result.ex = ex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
          result.ex2 = ex2;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing getMultiRecord", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing getMultiRecord");
          oprot.writeMessageBegin(new TMessage("getMultiRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("getMultiRecord", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class provideMulti implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        provideMulti_args args = new provideMulti_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("provideMulti", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        provideMulti_result result = new provideMulti_result();
        try {
          result.success = iface_.provideMulti(args.view_name, args.texts, args.forceUpdate);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
          result.suex = suex;
        } catch (edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
          result.afex = afex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing provideMulti", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing provideMulti");
          oprot.writeMessageBegin(new TMessage("provideMulti", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("provideMulti", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

    private class storeMultiRecord implements ProcessFunction {
      public void process(int seqid, TProtocol iprot, TProtocol oprot) throws TException
      {
        storeMultiRecord_args args = new storeMultiRecord_args();
        try {
          args.read(iprot);
        } catch (TProtocolException e) {
          iprot.readMessageEnd();
          TApplicationException x = new TApplicationException(TApplicationException.PROTOCOL_ERROR, e.getMessage());
          oprot.writeMessageBegin(new TMessage("storeMultiRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        iprot.readMessageEnd();
        storeMultiRecord_result result = new storeMultiRecord_result();
        try {
          iface_.storeMultiRecord(args.record);
        } catch (edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex) {
          result.ssex = ssex;
        } catch (Throwable th) {
          LOGGER.error("Internal error processing storeMultiRecord", th);
          TApplicationException x = new TApplicationException(TApplicationException.INTERNAL_ERROR, "Internal error processing storeMultiRecord");
          oprot.writeMessageBegin(new TMessage("storeMultiRecord", TMessageType.EXCEPTION, seqid));
          x.write(oprot);
          oprot.writeMessageEnd();
          oprot.getTransport().flush();
          return;
        }
        oprot.writeMessageBegin(new TMessage("storeMultiRecord", TMessageType.REPLY, seqid));
        result.write(oprot);
        oprot.writeMessageEnd();
        oprot.getTransport().flush();
      }

    }

  }

  public static class describeAnnotations_args implements TBase<describeAnnotations_args, describeAnnotations_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("describeAnnotations_args");



    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(describeAnnotations_args.class, metaDataMap);
    }

    public describeAnnotations_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public describeAnnotations_args(describeAnnotations_args other) {
    }

    public describeAnnotations_args deepCopy() {
      return new describeAnnotations_args(this);
    }

    @Deprecated
    public describeAnnotations_args clone() {
      return new describeAnnotations_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof describeAnnotations_args)
        return this.equals((describeAnnotations_args)that);
      return false;
    }

    public boolean equals(describeAnnotations_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      return builder.toHashCode();
    }

    public int compareTo(describeAnnotations_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      describeAnnotations_args typedOther = (describeAnnotations_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("describeAnnotations_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class describeAnnotations_result implements TBase<describeAnnotations_result, describeAnnotations_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("describeAnnotations_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.MAP, (short)0);

    public Map<String,String> success;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new MapMetaData(TType.MAP, 
              new FieldValueMetaData(TType.STRING), 
              new FieldValueMetaData(TType.STRING))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(describeAnnotations_result.class, metaDataMap);
    }

    public describeAnnotations_result() {
    }

    public describeAnnotations_result(
      Map<String,String> success)
    {
      this();
      this.success = success;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public describeAnnotations_result(describeAnnotations_result other) {
      if (other.isSetSuccess()) {
        Map<String,String> __this__success = new HashMap<String,String>();
        for (Map.Entry<String, String> other_element : other.success.entrySet()) {

          String other_element_key = other_element.getKey();
          String other_element_value = other_element.getValue();

          String __this__success_copy_key = other_element_key;

          String __this__success_copy_value = other_element_value;

          __this__success.put(__this__success_copy_key, __this__success_copy_value);
        }
        this.success = __this__success;
      }
    }

    public describeAnnotations_result deepCopy() {
      return new describeAnnotations_result(this);
    }

    @Deprecated
    public describeAnnotations_result clone() {
      return new describeAnnotations_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
    }

    public int getSuccessSize() {
      return (this.success == null) ? 0 : this.success.size();
    }

    public void putToSuccess(String key, String val) {
      if (this.success == null) {
        this.success = new HashMap<String,String>();
      }
      this.success.put(key, val);
    }

    public Map<String,String> getSuccess() {
      return this.success;
    }

    public describeAnnotations_result setSuccess(Map<String,String> success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Map<String,String>)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof describeAnnotations_result)
        return this.equals((describeAnnotations_result)that);
      return false;
    }

    public boolean equals(describeAnnotations_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      return builder.toHashCode();
    }

    public int compareTo(describeAnnotations_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      describeAnnotations_result typedOther = (describeAnnotations_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.MAP) {
              {
                TMap _map44 = iprot.readMapBegin();
                this.success = new HashMap<String,String>(2*_map44.size);
                for (int _i45 = 0; _i45 < _map44.size; ++_i45)
                {
                  String _key46;
                  String _val47;
                  _key46 = iprot.readString();
                  _val47 = iprot.readString();
                  this.success.put(_key46, _val47);
                }
                iprot.readMapEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        {
          oprot.writeMapBegin(new TMap(TType.STRING, TType.STRING, this.success.size()));
          for (Map.Entry<String, String> _iter48 : this.success.entrySet())
          {
            oprot.writeString(_iter48.getKey());
            oprot.writeString(_iter48.getValue());
          }
          oprot.writeMapEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("describeAnnotations_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class isCacheAvailable_args implements TBase<isCacheAvailable_args, isCacheAvailable_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("isCacheAvailable_args");



    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
;

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }
    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(isCacheAvailable_args.class, metaDataMap);
    }

    public isCacheAvailable_args() {
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public isCacheAvailable_args(isCacheAvailable_args other) {
    }

    public isCacheAvailable_args deepCopy() {
      return new isCacheAvailable_args(this);
    }

    @Deprecated
    public isCacheAvailable_args clone() {
      return new isCacheAvailable_args(this);
    }

    @Override
    public void clear() {
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof isCacheAvailable_args)
        return this.equals((isCacheAvailable_args)that);
      return false;
    }

    public boolean equals(isCacheAvailable_args that) {
      if (that == null)
        return false;

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      return builder.toHashCode();
    }

    public int compareTo(isCacheAvailable_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      isCacheAvailable_args typedOther = (isCacheAvailable_args)other;

      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("isCacheAvailable_args(");
      boolean first = true;

      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class isCacheAvailable_result implements TBase<isCacheAvailable_result, isCacheAvailable_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("isCacheAvailable_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.BOOL, (short)0);

    public boolean success;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __SUCCESS_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(isCacheAvailable_result.class, metaDataMap);
    }

    public isCacheAvailable_result() {
    }

    public isCacheAvailable_result(
      boolean success)
    {
      this();
      this.success = success;
      setSuccessIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public isCacheAvailable_result(isCacheAvailable_result other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      this.success = other.success;
    }

    public isCacheAvailable_result deepCopy() {
      return new isCacheAvailable_result(this);
    }

    @Deprecated
    public isCacheAvailable_result clone() {
      return new isCacheAvailable_result(this);
    }

    @Override
    public void clear() {
      setSuccessIsSet(false);
      this.success = false;
    }

    public boolean isSuccess() {
      return this.success;
    }

    public isCacheAvailable_result setSuccess(boolean success) {
      this.success = success;
      setSuccessIsSet(true);
      return this;
    }

    public void unsetSuccess() {
      __isset_bit_vector.clear(__SUCCESS_ISSET_ID);
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return __isset_bit_vector.get(__SUCCESS_ISSET_ID);
    }

    public void setSuccessIsSet(boolean value) {
      __isset_bit_vector.set(__SUCCESS_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return new Boolean(isSuccess());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof isCacheAvailable_result)
        return this.equals((isCacheAvailable_result)that);
      return false;
    }

    public boolean equals(isCacheAvailable_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true;
      boolean that_present_success = true;
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (this.success != that.success)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true;
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      return builder.toHashCode();
    }

    public int compareTo(isCacheAvailable_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      isCacheAvailable_result typedOther = (isCacheAvailable_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.BOOL) {
              this.success = iprot.readBool();
              setSuccessIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        oprot.writeBool(this.success);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("isCacheAvailable_result(");
      boolean first = true;

      sb.append("success:");
      sb.append(this.success);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class provide_args implements TBase<provide_args, provide_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("provide_args");

    private static final TField VIEW_NAME_FIELD_DESC = new TField("view_name", TType.STRING, (short)1);
    private static final TField TEXT_FIELD_DESC = new TField("text", TType.STRING, (short)2);
    private static final TField FORCE_UPDATE_FIELD_DESC = new TField("forceUpdate", TType.BOOL, (short)3);

    public String view_name;
    public String text;
    public boolean forceUpdate;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      VIEW_NAME((short)1, "view_name"),
      TEXT((short)2, "text"),
      FORCE_UPDATE((short)3, "forceUpdate");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // VIEW_NAME
            return VIEW_NAME;
          case 2: // TEXT
            return TEXT;
          case 3: // FORCE_UPDATE
            return FORCE_UPDATE;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __FORCEUPDATE_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.VIEW_NAME, new FieldMetaData("view_name", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      tmpMap.put(_Fields.TEXT, new FieldMetaData("text", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      tmpMap.put(_Fields.FORCE_UPDATE, new FieldMetaData("forceUpdate", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(provide_args.class, metaDataMap);
    }

    public provide_args() {
    }

    public provide_args(
      String view_name,
      String text,
      boolean forceUpdate)
    {
      this();
      this.view_name = view_name;
      this.text = text;
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public provide_args(provide_args other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      if (other.isSetView_name()) {
        this.view_name = other.view_name;
      }
      if (other.isSetText()) {
        this.text = other.text;
      }
      this.forceUpdate = other.forceUpdate;
    }

    public provide_args deepCopy() {
      return new provide_args(this);
    }

    @Deprecated
    public provide_args clone() {
      return new provide_args(this);
    }

    @Override
    public void clear() {
      this.view_name = null;
      this.text = null;
      setForceUpdateIsSet(false);
      this.forceUpdate = false;
    }

    public String getView_name() {
      return this.view_name;
    }

    public provide_args setView_name(String view_name) {
      this.view_name = view_name;
      return this;
    }

    public void unsetView_name() {
      this.view_name = null;
    }

    /** Returns true if field view_name is set (has been asigned a value) and false otherwise */
    public boolean isSetView_name() {
      return this.view_name != null;
    }

    public void setView_nameIsSet(boolean value) {
      if (!value) {
        this.view_name = null;
      }
    }

    public String getText() {
      return this.text;
    }

    public provide_args setText(String text) {
      this.text = text;
      return this;
    }

    public void unsetText() {
      this.text = null;
    }

    /** Returns true if field text is set (has been asigned a value) and false otherwise */
    public boolean isSetText() {
      return this.text != null;
    }

    public void setTextIsSet(boolean value) {
      if (!value) {
        this.text = null;
      }
    }

    public boolean isForceUpdate() {
      return this.forceUpdate;
    }

    public provide_args setForceUpdate(boolean forceUpdate) {
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
      return this;
    }

    public void unsetForceUpdate() {
      __isset_bit_vector.clear(__FORCEUPDATE_ISSET_ID);
    }

    /** Returns true if field forceUpdate is set (has been asigned a value) and false otherwise */
    public boolean isSetForceUpdate() {
      return __isset_bit_vector.get(__FORCEUPDATE_ISSET_ID);
    }

    public void setForceUpdateIsSet(boolean value) {
      __isset_bit_vector.set(__FORCEUPDATE_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case VIEW_NAME:
        if (value == null) {
          unsetView_name();
        } else {
          setView_name((String)value);
        }
        break;

      case TEXT:
        if (value == null) {
          unsetText();
        } else {
          setText((String)value);
        }
        break;

      case FORCE_UPDATE:
        if (value == null) {
          unsetForceUpdate();
        } else {
          setForceUpdate((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return getView_name();

      case TEXT:
        return getText();

      case FORCE_UPDATE:
        return new Boolean(isForceUpdate());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return isSetView_name();
      case TEXT:
        return isSetText();
      case FORCE_UPDATE:
        return isSetForceUpdate();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof provide_args)
        return this.equals((provide_args)that);
      return false;
    }

    public boolean equals(provide_args that) {
      if (that == null)
        return false;

      boolean this_present_view_name = true && this.isSetView_name();
      boolean that_present_view_name = true && that.isSetView_name();
      if (this_present_view_name || that_present_view_name) {
        if (!(this_present_view_name && that_present_view_name))
          return false;
        if (!this.view_name.equals(that.view_name))
          return false;
      }

      boolean this_present_text = true && this.isSetText();
      boolean that_present_text = true && that.isSetText();
      if (this_present_text || that_present_text) {
        if (!(this_present_text && that_present_text))
          return false;
        if (!this.text.equals(that.text))
          return false;
      }

      boolean this_present_forceUpdate = true;
      boolean that_present_forceUpdate = true;
      if (this_present_forceUpdate || that_present_forceUpdate) {
        if (!(this_present_forceUpdate && that_present_forceUpdate))
          return false;
        if (this.forceUpdate != that.forceUpdate)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_view_name = true && (isSetView_name());
      builder.append(present_view_name);
      if (present_view_name)
        builder.append(view_name);

      boolean present_text = true && (isSetText());
      builder.append(present_text);
      if (present_text)
        builder.append(text);

      boolean present_forceUpdate = true;
      builder.append(present_forceUpdate);
      if (present_forceUpdate)
        builder.append(forceUpdate);

      return builder.toHashCode();
    }

    public int compareTo(provide_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      provide_args typedOther = (provide_args)other;

      lastComparison = Boolean.valueOf(isSetView_name()).compareTo(typedOther.isSetView_name());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetView_name()) {        lastComparison = TBaseHelper.compareTo(this.view_name, typedOther.view_name);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetText()).compareTo(typedOther.isSetText());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetText()) {        lastComparison = TBaseHelper.compareTo(this.text, typedOther.text);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetForceUpdate()).compareTo(typedOther.isSetForceUpdate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetForceUpdate()) {        lastComparison = TBaseHelper.compareTo(this.forceUpdate, typedOther.forceUpdate);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // VIEW_NAME
            if (field.type == TType.STRING) {
              this.view_name = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // TEXT
            if (field.type == TType.STRING) {
              this.text = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 3: // FORCE_UPDATE
            if (field.type == TType.BOOL) {
              this.forceUpdate = iprot.readBool();
              setForceUpdateIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.view_name != null) {
        oprot.writeFieldBegin(VIEW_NAME_FIELD_DESC);
        oprot.writeString(this.view_name);
        oprot.writeFieldEnd();
      }
      if (this.text != null) {
        oprot.writeFieldBegin(TEXT_FIELD_DESC);
        oprot.writeString(this.text);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(FORCE_UPDATE_FIELD_DESC);
      oprot.writeBool(this.forceUpdate);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("provide_args(");
      boolean first = true;

      sb.append("view_name:");
      if (this.view_name == null) {
        sb.append("null");
      } else {
        sb.append(this.view_name);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("text:");
      if (this.text == null) {
        sb.append("null");
      } else {
        sb.append(this.text);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("forceUpdate:");
      sb.append(this.forceUpdate);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class provide_result implements TBase<provide_result, provide_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("provide_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField SUEX_FIELD_DESC = new TField("suex", TType.STRUCT, (short)1);
    private static final TField AFEX_FIELD_DESC = new TField("afex", TType.STRUCT, (short)2);

    public Record success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      SUEX((short)1, "suex"),
      AFEX((short)2, "afex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // SUEX
            return SUEX;
          case 2: // AFEX
            return AFEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.SUEX, new FieldMetaData("suex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.AFEX, new FieldMetaData("afex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(provide_result.class, metaDataMap);
    }

    public provide_result() {
    }

    public provide_result(
      Record success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex)
    {
      this();
      this.success = success;
      this.suex = suex;
      this.afex = afex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public provide_result(provide_result other) {
      if (other.isSetSuccess()) {
        this.success = new Record(other.success);
      }
      if (other.isSetSuex()) {
        this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.suex);
      }
      if (other.isSetAfex()) {
        this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.afex);
      }
    }

    public provide_result deepCopy() {
      return new provide_result(this);
    }

    @Deprecated
    public provide_result clone() {
      return new provide_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.suex = null;
      this.afex = null;
    }

    public Record getSuccess() {
      return this.success;
    }

    public provide_result setSuccess(Record success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getSuex() {
      return this.suex;
    }

    public provide_result setSuex(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
      this.suex = suex;
      return this;
    }

    public void unsetSuex() {
      this.suex = null;
    }

    /** Returns true if field suex is set (has been asigned a value) and false otherwise */
    public boolean isSetSuex() {
      return this.suex != null;
    }

    public void setSuexIsSet(boolean value) {
      if (!value) {
        this.suex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getAfex() {
      return this.afex;
    }

    public provide_result setAfex(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
      this.afex = afex;
      return this;
    }

    public void unsetAfex() {
      this.afex = null;
    }

    /** Returns true if field afex is set (has been asigned a value) and false otherwise */
    public boolean isSetAfex() {
      return this.afex != null;
    }

    public void setAfexIsSet(boolean value) {
      if (!value) {
        this.afex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Record)value);
        }
        break;

      case SUEX:
        if (value == null) {
          unsetSuex();
        } else {
          setSuex((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case AFEX:
        if (value == null) {
          unsetAfex();
        } else {
          setAfex((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case SUEX:
        return getSuex();

      case AFEX:
        return getAfex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case SUEX:
        return isSetSuex();
      case AFEX:
        return isSetAfex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof provide_result)
        return this.equals((provide_result)that);
      return false;
    }

    public boolean equals(provide_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_suex = true && this.isSetSuex();
      boolean that_present_suex = true && that.isSetSuex();
      if (this_present_suex || that_present_suex) {
        if (!(this_present_suex && that_present_suex))
          return false;
        if (!this.suex.equals(that.suex))
          return false;
      }

      boolean this_present_afex = true && this.isSetAfex();
      boolean that_present_afex = true && that.isSetAfex();
      if (this_present_afex || that_present_afex) {
        if (!(this_present_afex && that_present_afex))
          return false;
        if (!this.afex.equals(that.afex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_suex = true && (isSetSuex());
      builder.append(present_suex);
      if (present_suex)
        builder.append(suex);

      boolean present_afex = true && (isSetAfex());
      builder.append(present_afex);
      if (present_afex)
        builder.append(afex);

      return builder.toHashCode();
    }

    public int compareTo(provide_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      provide_result typedOther = (provide_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetSuex()).compareTo(typedOther.isSetSuex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuex()) {        lastComparison = TBaseHelper.compareTo(this.suex, typedOther.suex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetAfex()).compareTo(typedOther.isSetAfex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetAfex()) {        lastComparison = TBaseHelper.compareTo(this.afex, typedOther.afex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new Record();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // SUEX
            if (field.type == TType.STRUCT) {
              this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.suex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // AFEX
            if (field.type == TType.STRUCT) {
              this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.afex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetSuex()) {
        oprot.writeFieldBegin(SUEX_FIELD_DESC);
        this.suex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetAfex()) {
        oprot.writeFieldBegin(AFEX_FIELD_DESC);
        this.afex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("provide_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("suex:");
      if (this.suex == null) {
        sb.append("null");
      } else {
        sb.append(this.suex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("afex:");
      if (this.afex == null) {
        sb.append("null");
      } else {
        sb.append(this.afex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class wsprovide_args implements TBase<wsprovide_args, wsprovide_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("wsprovide_args");

    private static final TField VIEW_NAME_FIELD_DESC = new TField("view_name", TType.STRING, (short)1);
    private static final TField SENTENCES_FIELD_DESC = new TField("sentences", TType.LIST, (short)2);
    private static final TField FORCE_UPDATE_FIELD_DESC = new TField("forceUpdate", TType.BOOL, (short)3);

    public String view_name;
    public List<String> sentences;
    public boolean forceUpdate;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      VIEW_NAME((short)1, "view_name"),
      SENTENCES((short)2, "sentences"),
      FORCE_UPDATE((short)3, "forceUpdate");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // VIEW_NAME
            return VIEW_NAME;
          case 2: // SENTENCES
            return SENTENCES;
          case 3: // FORCE_UPDATE
            return FORCE_UPDATE;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __FORCEUPDATE_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.VIEW_NAME, new FieldMetaData("view_name", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      tmpMap.put(_Fields.SENTENCES, new FieldMetaData("sentences", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new FieldValueMetaData(TType.STRING))));
      tmpMap.put(_Fields.FORCE_UPDATE, new FieldMetaData("forceUpdate", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(wsprovide_args.class, metaDataMap);
    }

    public wsprovide_args() {
    }

    public wsprovide_args(
      String view_name,
      List<String> sentences,
      boolean forceUpdate)
    {
      this();
      this.view_name = view_name;
      this.sentences = sentences;
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public wsprovide_args(wsprovide_args other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      if (other.isSetView_name()) {
        this.view_name = other.view_name;
      }
      if (other.isSetSentences()) {
        List<String> __this__sentences = new ArrayList<String>();
        for (String other_element : other.sentences) {
          __this__sentences.add(other_element);
        }
        this.sentences = __this__sentences;
      }
      this.forceUpdate = other.forceUpdate;
    }

    public wsprovide_args deepCopy() {
      return new wsprovide_args(this);
    }

    @Deprecated
    public wsprovide_args clone() {
      return new wsprovide_args(this);
    }

    @Override
    public void clear() {
      this.view_name = null;
      this.sentences = null;
      setForceUpdateIsSet(false);
      this.forceUpdate = false;
    }

    public String getView_name() {
      return this.view_name;
    }

    public wsprovide_args setView_name(String view_name) {
      this.view_name = view_name;
      return this;
    }

    public void unsetView_name() {
      this.view_name = null;
    }

    /** Returns true if field view_name is set (has been asigned a value) and false otherwise */
    public boolean isSetView_name() {
      return this.view_name != null;
    }

    public void setView_nameIsSet(boolean value) {
      if (!value) {
        this.view_name = null;
      }
    }

    public int getSentencesSize() {
      return (this.sentences == null) ? 0 : this.sentences.size();
    }

    public java.util.Iterator<String> getSentencesIterator() {
      return (this.sentences == null) ? null : this.sentences.iterator();
    }

    public void addToSentences(String elem) {
      if (this.sentences == null) {
        this.sentences = new ArrayList<String>();
      }
      this.sentences.add(elem);
    }

    public List<String> getSentences() {
      return this.sentences;
    }

    public wsprovide_args setSentences(List<String> sentences) {
      this.sentences = sentences;
      return this;
    }

    public void unsetSentences() {
      this.sentences = null;
    }

    /** Returns true if field sentences is set (has been asigned a value) and false otherwise */
    public boolean isSetSentences() {
      return this.sentences != null;
    }

    public void setSentencesIsSet(boolean value) {
      if (!value) {
        this.sentences = null;
      }
    }

    public boolean isForceUpdate() {
      return this.forceUpdate;
    }

    public wsprovide_args setForceUpdate(boolean forceUpdate) {
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
      return this;
    }

    public void unsetForceUpdate() {
      __isset_bit_vector.clear(__FORCEUPDATE_ISSET_ID);
    }

    /** Returns true if field forceUpdate is set (has been asigned a value) and false otherwise */
    public boolean isSetForceUpdate() {
      return __isset_bit_vector.get(__FORCEUPDATE_ISSET_ID);
    }

    public void setForceUpdateIsSet(boolean value) {
      __isset_bit_vector.set(__FORCEUPDATE_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case VIEW_NAME:
        if (value == null) {
          unsetView_name();
        } else {
          setView_name((String)value);
        }
        break;

      case SENTENCES:
        if (value == null) {
          unsetSentences();
        } else {
          setSentences((List<String>)value);
        }
        break;

      case FORCE_UPDATE:
        if (value == null) {
          unsetForceUpdate();
        } else {
          setForceUpdate((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return getView_name();

      case SENTENCES:
        return getSentences();

      case FORCE_UPDATE:
        return new Boolean(isForceUpdate());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return isSetView_name();
      case SENTENCES:
        return isSetSentences();
      case FORCE_UPDATE:
        return isSetForceUpdate();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof wsprovide_args)
        return this.equals((wsprovide_args)that);
      return false;
    }

    public boolean equals(wsprovide_args that) {
      if (that == null)
        return false;

      boolean this_present_view_name = true && this.isSetView_name();
      boolean that_present_view_name = true && that.isSetView_name();
      if (this_present_view_name || that_present_view_name) {
        if (!(this_present_view_name && that_present_view_name))
          return false;
        if (!this.view_name.equals(that.view_name))
          return false;
      }

      boolean this_present_sentences = true && this.isSetSentences();
      boolean that_present_sentences = true && that.isSetSentences();
      if (this_present_sentences || that_present_sentences) {
        if (!(this_present_sentences && that_present_sentences))
          return false;
        if (!this.sentences.equals(that.sentences))
          return false;
      }

      boolean this_present_forceUpdate = true;
      boolean that_present_forceUpdate = true;
      if (this_present_forceUpdate || that_present_forceUpdate) {
        if (!(this_present_forceUpdate && that_present_forceUpdate))
          return false;
        if (this.forceUpdate != that.forceUpdate)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_view_name = true && (isSetView_name());
      builder.append(present_view_name);
      if (present_view_name)
        builder.append(view_name);

      boolean present_sentences = true && (isSetSentences());
      builder.append(present_sentences);
      if (present_sentences)
        builder.append(sentences);

      boolean present_forceUpdate = true;
      builder.append(present_forceUpdate);
      if (present_forceUpdate)
        builder.append(forceUpdate);

      return builder.toHashCode();
    }

    public int compareTo(wsprovide_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      wsprovide_args typedOther = (wsprovide_args)other;

      lastComparison = Boolean.valueOf(isSetView_name()).compareTo(typedOther.isSetView_name());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetView_name()) {        lastComparison = TBaseHelper.compareTo(this.view_name, typedOther.view_name);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetSentences()).compareTo(typedOther.isSetSentences());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSentences()) {        lastComparison = TBaseHelper.compareTo(this.sentences, typedOther.sentences);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetForceUpdate()).compareTo(typedOther.isSetForceUpdate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetForceUpdate()) {        lastComparison = TBaseHelper.compareTo(this.forceUpdate, typedOther.forceUpdate);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // VIEW_NAME
            if (field.type == TType.STRING) {
              this.view_name = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // SENTENCES
            if (field.type == TType.LIST) {
              {
                TList _list49 = iprot.readListBegin();
                this.sentences = new ArrayList<String>(_list49.size);
                for (int _i50 = 0; _i50 < _list49.size; ++_i50)
                {
                  String _elem51;
                  _elem51 = iprot.readString();
                  this.sentences.add(_elem51);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 3: // FORCE_UPDATE
            if (field.type == TType.BOOL) {
              this.forceUpdate = iprot.readBool();
              setForceUpdateIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.view_name != null) {
        oprot.writeFieldBegin(VIEW_NAME_FIELD_DESC);
        oprot.writeString(this.view_name);
        oprot.writeFieldEnd();
      }
      if (this.sentences != null) {
        oprot.writeFieldBegin(SENTENCES_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRING, this.sentences.size()));
          for (String _iter52 : this.sentences)
          {
            oprot.writeString(_iter52);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(FORCE_UPDATE_FIELD_DESC);
      oprot.writeBool(this.forceUpdate);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("wsprovide_args(");
      boolean first = true;

      sb.append("view_name:");
      if (this.view_name == null) {
        sb.append("null");
      } else {
        sb.append(this.view_name);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("sentences:");
      if (this.sentences == null) {
        sb.append("null");
      } else {
        sb.append(this.sentences);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("forceUpdate:");
      sb.append(this.forceUpdate);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class wsprovide_result implements TBase<wsprovide_result, wsprovide_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("wsprovide_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField SUEX_FIELD_DESC = new TField("suex", TType.STRUCT, (short)1);
    private static final TField AFEX_FIELD_DESC = new TField("afex", TType.STRUCT, (short)2);

    public Record success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      SUEX((short)1, "suex"),
      AFEX((short)2, "afex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // SUEX
            return SUEX;
          case 2: // AFEX
            return AFEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.SUEX, new FieldMetaData("suex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.AFEX, new FieldMetaData("afex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(wsprovide_result.class, metaDataMap);
    }

    public wsprovide_result() {
    }

    public wsprovide_result(
      Record success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex)
    {
      this();
      this.success = success;
      this.suex = suex;
      this.afex = afex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public wsprovide_result(wsprovide_result other) {
      if (other.isSetSuccess()) {
        this.success = new Record(other.success);
      }
      if (other.isSetSuex()) {
        this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.suex);
      }
      if (other.isSetAfex()) {
        this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.afex);
      }
    }

    public wsprovide_result deepCopy() {
      return new wsprovide_result(this);
    }

    @Deprecated
    public wsprovide_result clone() {
      return new wsprovide_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.suex = null;
      this.afex = null;
    }

    public Record getSuccess() {
      return this.success;
    }

    public wsprovide_result setSuccess(Record success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getSuex() {
      return this.suex;
    }

    public wsprovide_result setSuex(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
      this.suex = suex;
      return this;
    }

    public void unsetSuex() {
      this.suex = null;
    }

    /** Returns true if field suex is set (has been asigned a value) and false otherwise */
    public boolean isSetSuex() {
      return this.suex != null;
    }

    public void setSuexIsSet(boolean value) {
      if (!value) {
        this.suex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getAfex() {
      return this.afex;
    }

    public wsprovide_result setAfex(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
      this.afex = afex;
      return this;
    }

    public void unsetAfex() {
      this.afex = null;
    }

    /** Returns true if field afex is set (has been asigned a value) and false otherwise */
    public boolean isSetAfex() {
      return this.afex != null;
    }

    public void setAfexIsSet(boolean value) {
      if (!value) {
        this.afex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Record)value);
        }
        break;

      case SUEX:
        if (value == null) {
          unsetSuex();
        } else {
          setSuex((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case AFEX:
        if (value == null) {
          unsetAfex();
        } else {
          setAfex((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case SUEX:
        return getSuex();

      case AFEX:
        return getAfex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case SUEX:
        return isSetSuex();
      case AFEX:
        return isSetAfex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof wsprovide_result)
        return this.equals((wsprovide_result)that);
      return false;
    }

    public boolean equals(wsprovide_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_suex = true && this.isSetSuex();
      boolean that_present_suex = true && that.isSetSuex();
      if (this_present_suex || that_present_suex) {
        if (!(this_present_suex && that_present_suex))
          return false;
        if (!this.suex.equals(that.suex))
          return false;
      }

      boolean this_present_afex = true && this.isSetAfex();
      boolean that_present_afex = true && that.isSetAfex();
      if (this_present_afex || that_present_afex) {
        if (!(this_present_afex && that_present_afex))
          return false;
        if (!this.afex.equals(that.afex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_suex = true && (isSetSuex());
      builder.append(present_suex);
      if (present_suex)
        builder.append(suex);

      boolean present_afex = true && (isSetAfex());
      builder.append(present_afex);
      if (present_afex)
        builder.append(afex);

      return builder.toHashCode();
    }

    public int compareTo(wsprovide_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      wsprovide_result typedOther = (wsprovide_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetSuex()).compareTo(typedOther.isSetSuex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuex()) {        lastComparison = TBaseHelper.compareTo(this.suex, typedOther.suex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetAfex()).compareTo(typedOther.isSetAfex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetAfex()) {        lastComparison = TBaseHelper.compareTo(this.afex, typedOther.afex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new Record();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // SUEX
            if (field.type == TType.STRUCT) {
              this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.suex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // AFEX
            if (field.type == TType.STRUCT) {
              this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.afex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetSuex()) {
        oprot.writeFieldBegin(SUEX_FIELD_DESC);
        this.suex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetAfex()) {
        oprot.writeFieldBegin(AFEX_FIELD_DESC);
        this.afex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("wsprovide_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("suex:");
      if (this.suex == null) {
        sb.append("null");
      } else {
        sb.append(this.suex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("afex:");
      if (this.afex == null) {
        sb.append("null");
      } else {
        sb.append(this.afex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class performAnnotation_args implements TBase<performAnnotation_args, performAnnotation_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("performAnnotation_args");

    private static final TField RECORD_FIELD_DESC = new TField("record", TType.STRUCT, (short)1);
    private static final TField VIEW_NAME_FIELD_DESC = new TField("view_name", TType.STRING, (short)2);
    private static final TField FORCE_UPDATE_FIELD_DESC = new TField("forceUpdate", TType.BOOL, (short)3);

    public Record record;
    public String view_name;
    public boolean forceUpdate;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      RECORD((short)1, "record"),
      VIEW_NAME((short)2, "view_name"),
      FORCE_UPDATE((short)3, "forceUpdate");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // RECORD
            return RECORD;
          case 2: // VIEW_NAME
            return VIEW_NAME;
          case 3: // FORCE_UPDATE
            return FORCE_UPDATE;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __FORCEUPDATE_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.RECORD, new FieldMetaData("record", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.VIEW_NAME, new FieldMetaData("view_name", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      tmpMap.put(_Fields.FORCE_UPDATE, new FieldMetaData("forceUpdate", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(performAnnotation_args.class, metaDataMap);
    }

    public performAnnotation_args() {
    }

    public performAnnotation_args(
      Record record,
      String view_name,
      boolean forceUpdate)
    {
      this();
      this.record = record;
      this.view_name = view_name;
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public performAnnotation_args(performAnnotation_args other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      if (other.isSetRecord()) {
        this.record = new Record(other.record);
      }
      if (other.isSetView_name()) {
        this.view_name = other.view_name;
      }
      this.forceUpdate = other.forceUpdate;
    }

    public performAnnotation_args deepCopy() {
      return new performAnnotation_args(this);
    }

    @Deprecated
    public performAnnotation_args clone() {
      return new performAnnotation_args(this);
    }

    @Override
    public void clear() {
      this.record = null;
      this.view_name = null;
      setForceUpdateIsSet(false);
      this.forceUpdate = false;
    }

    public Record getRecord() {
      return this.record;
    }

    public performAnnotation_args setRecord(Record record) {
      this.record = record;
      return this;
    }

    public void unsetRecord() {
      this.record = null;
    }

    /** Returns true if field record is set (has been asigned a value) and false otherwise */
    public boolean isSetRecord() {
      return this.record != null;
    }

    public void setRecordIsSet(boolean value) {
      if (!value) {
        this.record = null;
      }
    }

    public String getView_name() {
      return this.view_name;
    }

    public performAnnotation_args setView_name(String view_name) {
      this.view_name = view_name;
      return this;
    }

    public void unsetView_name() {
      this.view_name = null;
    }

    /** Returns true if field view_name is set (has been asigned a value) and false otherwise */
    public boolean isSetView_name() {
      return this.view_name != null;
    }

    public void setView_nameIsSet(boolean value) {
      if (!value) {
        this.view_name = null;
      }
    }

    public boolean isForceUpdate() {
      return this.forceUpdate;
    }

    public performAnnotation_args setForceUpdate(boolean forceUpdate) {
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
      return this;
    }

    public void unsetForceUpdate() {
      __isset_bit_vector.clear(__FORCEUPDATE_ISSET_ID);
    }

    /** Returns true if field forceUpdate is set (has been asigned a value) and false otherwise */
    public boolean isSetForceUpdate() {
      return __isset_bit_vector.get(__FORCEUPDATE_ISSET_ID);
    }

    public void setForceUpdateIsSet(boolean value) {
      __isset_bit_vector.set(__FORCEUPDATE_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case RECORD:
        if (value == null) {
          unsetRecord();
        } else {
          setRecord((Record)value);
        }
        break;

      case VIEW_NAME:
        if (value == null) {
          unsetView_name();
        } else {
          setView_name((String)value);
        }
        break;

      case FORCE_UPDATE:
        if (value == null) {
          unsetForceUpdate();
        } else {
          setForceUpdate((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case RECORD:
        return getRecord();

      case VIEW_NAME:
        return getView_name();

      case FORCE_UPDATE:
        return new Boolean(isForceUpdate());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case RECORD:
        return isSetRecord();
      case VIEW_NAME:
        return isSetView_name();
      case FORCE_UPDATE:
        return isSetForceUpdate();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof performAnnotation_args)
        return this.equals((performAnnotation_args)that);
      return false;
    }

    public boolean equals(performAnnotation_args that) {
      if (that == null)
        return false;

      boolean this_present_record = true && this.isSetRecord();
      boolean that_present_record = true && that.isSetRecord();
      if (this_present_record || that_present_record) {
        if (!(this_present_record && that_present_record))
          return false;
        if (!this.record.equals(that.record))
          return false;
      }

      boolean this_present_view_name = true && this.isSetView_name();
      boolean that_present_view_name = true && that.isSetView_name();
      if (this_present_view_name || that_present_view_name) {
        if (!(this_present_view_name && that_present_view_name))
          return false;
        if (!this.view_name.equals(that.view_name))
          return false;
      }

      boolean this_present_forceUpdate = true;
      boolean that_present_forceUpdate = true;
      if (this_present_forceUpdate || that_present_forceUpdate) {
        if (!(this_present_forceUpdate && that_present_forceUpdate))
          return false;
        if (this.forceUpdate != that.forceUpdate)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_record = true && (isSetRecord());
      builder.append(present_record);
      if (present_record)
        builder.append(record);

      boolean present_view_name = true && (isSetView_name());
      builder.append(present_view_name);
      if (present_view_name)
        builder.append(view_name);

      boolean present_forceUpdate = true;
      builder.append(present_forceUpdate);
      if (present_forceUpdate)
        builder.append(forceUpdate);

      return builder.toHashCode();
    }

    public int compareTo(performAnnotation_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      performAnnotation_args typedOther = (performAnnotation_args)other;

      lastComparison = Boolean.valueOf(isSetRecord()).compareTo(typedOther.isSetRecord());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRecord()) {        lastComparison = TBaseHelper.compareTo(this.record, typedOther.record);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetView_name()).compareTo(typedOther.isSetView_name());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetView_name()) {        lastComparison = TBaseHelper.compareTo(this.view_name, typedOther.view_name);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetForceUpdate()).compareTo(typedOther.isSetForceUpdate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetForceUpdate()) {        lastComparison = TBaseHelper.compareTo(this.forceUpdate, typedOther.forceUpdate);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // RECORD
            if (field.type == TType.STRUCT) {
              this.record = new Record();
              this.record.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // VIEW_NAME
            if (field.type == TType.STRING) {
              this.view_name = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 3: // FORCE_UPDATE
            if (field.type == TType.BOOL) {
              this.forceUpdate = iprot.readBool();
              setForceUpdateIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.record != null) {
        oprot.writeFieldBegin(RECORD_FIELD_DESC);
        this.record.write(oprot);
        oprot.writeFieldEnd();
      }
      if (this.view_name != null) {
        oprot.writeFieldBegin(VIEW_NAME_FIELD_DESC);
        oprot.writeString(this.view_name);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(FORCE_UPDATE_FIELD_DESC);
      oprot.writeBool(this.forceUpdate);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("performAnnotation_args(");
      boolean first = true;

      sb.append("record:");
      if (this.record == null) {
        sb.append("null");
      } else {
        sb.append(this.record);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("view_name:");
      if (this.view_name == null) {
        sb.append("null");
      } else {
        sb.append(this.view_name);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("forceUpdate:");
      sb.append(this.forceUpdate);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class performAnnotation_result implements TBase<performAnnotation_result, performAnnotation_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("performAnnotation_result");

    private static final TField SUEX_FIELD_DESC = new TField("suex", TType.STRUCT, (short)1);
    private static final TField AFEX_FIELD_DESC = new TField("afex", TType.STRUCT, (short)2);

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUEX((short)1, "suex"),
      AFEX((short)2, "afex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // SUEX
            return SUEX;
          case 2: // AFEX
            return AFEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUEX, new FieldMetaData("suex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.AFEX, new FieldMetaData("afex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(performAnnotation_result.class, metaDataMap);
    }

    public performAnnotation_result() {
    }

    public performAnnotation_result(
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex)
    {
      this();
      this.suex = suex;
      this.afex = afex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public performAnnotation_result(performAnnotation_result other) {
      if (other.isSetSuex()) {
        this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.suex);
      }
      if (other.isSetAfex()) {
        this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.afex);
      }
    }

    public performAnnotation_result deepCopy() {
      return new performAnnotation_result(this);
    }

    @Deprecated
    public performAnnotation_result clone() {
      return new performAnnotation_result(this);
    }

    @Override
    public void clear() {
      this.suex = null;
      this.afex = null;
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getSuex() {
      return this.suex;
    }

    public performAnnotation_result setSuex(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
      this.suex = suex;
      return this;
    }

    public void unsetSuex() {
      this.suex = null;
    }

    /** Returns true if field suex is set (has been asigned a value) and false otherwise */
    public boolean isSetSuex() {
      return this.suex != null;
    }

    public void setSuexIsSet(boolean value) {
      if (!value) {
        this.suex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getAfex() {
      return this.afex;
    }

    public performAnnotation_result setAfex(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
      this.afex = afex;
      return this;
    }

    public void unsetAfex() {
      this.afex = null;
    }

    /** Returns true if field afex is set (has been asigned a value) and false otherwise */
    public boolean isSetAfex() {
      return this.afex != null;
    }

    public void setAfexIsSet(boolean value) {
      if (!value) {
        this.afex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUEX:
        if (value == null) {
          unsetSuex();
        } else {
          setSuex((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case AFEX:
        if (value == null) {
          unsetAfex();
        } else {
          setAfex((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUEX:
        return getSuex();

      case AFEX:
        return getAfex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUEX:
        return isSetSuex();
      case AFEX:
        return isSetAfex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof performAnnotation_result)
        return this.equals((performAnnotation_result)that);
      return false;
    }

    public boolean equals(performAnnotation_result that) {
      if (that == null)
        return false;

      boolean this_present_suex = true && this.isSetSuex();
      boolean that_present_suex = true && that.isSetSuex();
      if (this_present_suex || that_present_suex) {
        if (!(this_present_suex && that_present_suex))
          return false;
        if (!this.suex.equals(that.suex))
          return false;
      }

      boolean this_present_afex = true && this.isSetAfex();
      boolean that_present_afex = true && that.isSetAfex();
      if (this_present_afex || that_present_afex) {
        if (!(this_present_afex && that_present_afex))
          return false;
        if (!this.afex.equals(that.afex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_suex = true && (isSetSuex());
      builder.append(present_suex);
      if (present_suex)
        builder.append(suex);

      boolean present_afex = true && (isSetAfex());
      builder.append(present_afex);
      if (present_afex)
        builder.append(afex);

      return builder.toHashCode();
    }

    public int compareTo(performAnnotation_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      performAnnotation_result typedOther = (performAnnotation_result)other;

      lastComparison = Boolean.valueOf(isSetSuex()).compareTo(typedOther.isSetSuex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuex()) {        lastComparison = TBaseHelper.compareTo(this.suex, typedOther.suex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetAfex()).compareTo(typedOther.isSetAfex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetAfex()) {        lastComparison = TBaseHelper.compareTo(this.afex, typedOther.afex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // SUEX
            if (field.type == TType.STRUCT) {
              this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.suex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // AFEX
            if (field.type == TType.STRUCT) {
              this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.afex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuex()) {
        oprot.writeFieldBegin(SUEX_FIELD_DESC);
        this.suex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetAfex()) {
        oprot.writeFieldBegin(AFEX_FIELD_DESC);
        this.afex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("performAnnotation_result(");
      boolean first = true;

      sb.append("suex:");
      if (this.suex == null) {
        sb.append("null");
      } else {
        sb.append(this.suex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("afex:");
      if (this.afex == null) {
        sb.append("null");
      } else {
        sb.append(this.afex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getRecord_args implements TBase<getRecord_args, getRecord_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getRecord_args");

    private static final TField TEXT_FIELD_DESC = new TField("text", TType.STRING, (short)1);

    public String text;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      TEXT((short)1, "text");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // TEXT
            return TEXT;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.TEXT, new FieldMetaData("text", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getRecord_args.class, metaDataMap);
    }

    public getRecord_args() {
    }

    public getRecord_args(
      String text)
    {
      this();
      this.text = text;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getRecord_args(getRecord_args other) {
      if (other.isSetText()) {
        this.text = other.text;
      }
    }

    public getRecord_args deepCopy() {
      return new getRecord_args(this);
    }

    @Deprecated
    public getRecord_args clone() {
      return new getRecord_args(this);
    }

    @Override
    public void clear() {
      this.text = null;
    }

    public String getText() {
      return this.text;
    }

    public getRecord_args setText(String text) {
      this.text = text;
      return this;
    }

    public void unsetText() {
      this.text = null;
    }

    /** Returns true if field text is set (has been asigned a value) and false otherwise */
    public boolean isSetText() {
      return this.text != null;
    }

    public void setTextIsSet(boolean value) {
      if (!value) {
        this.text = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case TEXT:
        if (value == null) {
          unsetText();
        } else {
          setText((String)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case TEXT:
        return getText();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case TEXT:
        return isSetText();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getRecord_args)
        return this.equals((getRecord_args)that);
      return false;
    }

    public boolean equals(getRecord_args that) {
      if (that == null)
        return false;

      boolean this_present_text = true && this.isSetText();
      boolean that_present_text = true && that.isSetText();
      if (this_present_text || that_present_text) {
        if (!(this_present_text && that_present_text))
          return false;
        if (!this.text.equals(that.text))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_text = true && (isSetText());
      builder.append(present_text);
      if (present_text)
        builder.append(text);

      return builder.toHashCode();
    }

    public int compareTo(getRecord_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getRecord_args typedOther = (getRecord_args)other;

      lastComparison = Boolean.valueOf(isSetText()).compareTo(typedOther.isSetText());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetText()) {        lastComparison = TBaseHelper.compareTo(this.text, typedOther.text);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // TEXT
            if (field.type == TType.STRING) {
              this.text = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.text != null) {
        oprot.writeFieldBegin(TEXT_FIELD_DESC);
        oprot.writeString(this.text);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getRecord_args(");
      boolean first = true;

      sb.append("text:");
      if (this.text == null) {
        sb.append("null");
      } else {
        sb.append(this.text);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getRecord_result implements TBase<getRecord_result, getRecord_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getRecord_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField EX_FIELD_DESC = new TField("ex", TType.STRUCT, (short)1);
    private static final TField EX2_FIELD_DESC = new TField("ex2", TType.STRUCT, (short)2);

    public Record success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      EX((short)1, "ex"),
      EX2((short)2, "ex2");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // EX
            return EX;
          case 2: // EX2
            return EX2;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.EX, new FieldMetaData("ex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.EX2, new FieldMetaData("ex2", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getRecord_result.class, metaDataMap);
    }

    public getRecord_result() {
    }

    public getRecord_result(
      Record success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2)
    {
      this();
      this.success = success;
      this.ex = ex;
      this.ex2 = ex2;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getRecord_result(getRecord_result other) {
      if (other.isSetSuccess()) {
        this.success = new Record(other.success);
      }
      if (other.isSetEx()) {
        this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.ex);
      }
      if (other.isSetEx2()) {
        this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.ex2);
      }
    }

    public getRecord_result deepCopy() {
      return new getRecord_result(this);
    }

    @Deprecated
    public getRecord_result clone() {
      return new getRecord_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.ex = null;
      this.ex2 = null;
    }

    public Record getSuccess() {
      return this.success;
    }

    public getRecord_result setSuccess(Record success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getEx() {
      return this.ex;
    }

    public getRecord_result setEx(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
      this.ex = ex;
      return this;
    }

    public void unsetEx() {
      this.ex = null;
    }

    /** Returns true if field ex is set (has been asigned a value) and false otherwise */
    public boolean isSetEx() {
      return this.ex != null;
    }

    public void setExIsSet(boolean value) {
      if (!value) {
        this.ex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getEx2() {
      return this.ex2;
    }

    public getRecord_result setEx2(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
      this.ex2 = ex2;
      return this;
    }

    public void unsetEx2() {
      this.ex2 = null;
    }

    /** Returns true if field ex2 is set (has been asigned a value) and false otherwise */
    public boolean isSetEx2() {
      return this.ex2 != null;
    }

    public void setEx2IsSet(boolean value) {
      if (!value) {
        this.ex2 = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Record)value);
        }
        break;

      case EX:
        if (value == null) {
          unsetEx();
        } else {
          setEx((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case EX2:
        if (value == null) {
          unsetEx2();
        } else {
          setEx2((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case EX:
        return getEx();

      case EX2:
        return getEx2();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case EX:
        return isSetEx();
      case EX2:
        return isSetEx2();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getRecord_result)
        return this.equals((getRecord_result)that);
      return false;
    }

    public boolean equals(getRecord_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_ex = true && this.isSetEx();
      boolean that_present_ex = true && that.isSetEx();
      if (this_present_ex || that_present_ex) {
        if (!(this_present_ex && that_present_ex))
          return false;
        if (!this.ex.equals(that.ex))
          return false;
      }

      boolean this_present_ex2 = true && this.isSetEx2();
      boolean that_present_ex2 = true && that.isSetEx2();
      if (this_present_ex2 || that_present_ex2) {
        if (!(this_present_ex2 && that_present_ex2))
          return false;
        if (!this.ex2.equals(that.ex2))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_ex = true && (isSetEx());
      builder.append(present_ex);
      if (present_ex)
        builder.append(ex);

      boolean present_ex2 = true && (isSetEx2());
      builder.append(present_ex2);
      if (present_ex2)
        builder.append(ex2);

      return builder.toHashCode();
    }

    public int compareTo(getRecord_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getRecord_result typedOther = (getRecord_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx()).compareTo(typedOther.isSetEx());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx()) {        lastComparison = TBaseHelper.compareTo(this.ex, typedOther.ex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx2()).compareTo(typedOther.isSetEx2());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx2()) {        lastComparison = TBaseHelper.compareTo(this.ex2, typedOther.ex2);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new Record();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // EX
            if (field.type == TType.STRUCT) {
              this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.ex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // EX2
            if (field.type == TType.STRUCT) {
              this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.ex2.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx()) {
        oprot.writeFieldBegin(EX_FIELD_DESC);
        this.ex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx2()) {
        oprot.writeFieldBegin(EX2_FIELD_DESC);
        this.ex2.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getRecord_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex:");
      if (this.ex == null) {
        sb.append("null");
      } else {
        sb.append(this.ex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex2:");
      if (this.ex2 == null) {
        sb.append("null");
      } else {
        sb.append(this.ex2);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class wsgetRecord_args implements TBase<wsgetRecord_args, wsgetRecord_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("wsgetRecord_args");

    private static final TField SENTENCES_FIELD_DESC = new TField("sentences", TType.LIST, (short)1);

    public List<String> sentences;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SENTENCES((short)1, "sentences");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // SENTENCES
            return SENTENCES;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SENTENCES, new FieldMetaData("sentences", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new FieldValueMetaData(TType.STRING))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(wsgetRecord_args.class, metaDataMap);
    }

    public wsgetRecord_args() {
    }

    public wsgetRecord_args(
      List<String> sentences)
    {
      this();
      this.sentences = sentences;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public wsgetRecord_args(wsgetRecord_args other) {
      if (other.isSetSentences()) {
        List<String> __this__sentences = new ArrayList<String>();
        for (String other_element : other.sentences) {
          __this__sentences.add(other_element);
        }
        this.sentences = __this__sentences;
      }
    }

    public wsgetRecord_args deepCopy() {
      return new wsgetRecord_args(this);
    }

    @Deprecated
    public wsgetRecord_args clone() {
      return new wsgetRecord_args(this);
    }

    @Override
    public void clear() {
      this.sentences = null;
    }

    public int getSentencesSize() {
      return (this.sentences == null) ? 0 : this.sentences.size();
    }

    public java.util.Iterator<String> getSentencesIterator() {
      return (this.sentences == null) ? null : this.sentences.iterator();
    }

    public void addToSentences(String elem) {
      if (this.sentences == null) {
        this.sentences = new ArrayList<String>();
      }
      this.sentences.add(elem);
    }

    public List<String> getSentences() {
      return this.sentences;
    }

    public wsgetRecord_args setSentences(List<String> sentences) {
      this.sentences = sentences;
      return this;
    }

    public void unsetSentences() {
      this.sentences = null;
    }

    /** Returns true if field sentences is set (has been asigned a value) and false otherwise */
    public boolean isSetSentences() {
      return this.sentences != null;
    }

    public void setSentencesIsSet(boolean value) {
      if (!value) {
        this.sentences = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SENTENCES:
        if (value == null) {
          unsetSentences();
        } else {
          setSentences((List<String>)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SENTENCES:
        return getSentences();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SENTENCES:
        return isSetSentences();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof wsgetRecord_args)
        return this.equals((wsgetRecord_args)that);
      return false;
    }

    public boolean equals(wsgetRecord_args that) {
      if (that == null)
        return false;

      boolean this_present_sentences = true && this.isSetSentences();
      boolean that_present_sentences = true && that.isSetSentences();
      if (this_present_sentences || that_present_sentences) {
        if (!(this_present_sentences && that_present_sentences))
          return false;
        if (!this.sentences.equals(that.sentences))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_sentences = true && (isSetSentences());
      builder.append(present_sentences);
      if (present_sentences)
        builder.append(sentences);

      return builder.toHashCode();
    }

    public int compareTo(wsgetRecord_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      wsgetRecord_args typedOther = (wsgetRecord_args)other;

      lastComparison = Boolean.valueOf(isSetSentences()).compareTo(typedOther.isSetSentences());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSentences()) {        lastComparison = TBaseHelper.compareTo(this.sentences, typedOther.sentences);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // SENTENCES
            if (field.type == TType.LIST) {
              {
                TList _list53 = iprot.readListBegin();
                this.sentences = new ArrayList<String>(_list53.size);
                for (int _i54 = 0; _i54 < _list53.size; ++_i54)
                {
                  String _elem55;
                  _elem55 = iprot.readString();
                  this.sentences.add(_elem55);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.sentences != null) {
        oprot.writeFieldBegin(SENTENCES_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRING, this.sentences.size()));
          for (String _iter56 : this.sentences)
          {
            oprot.writeString(_iter56);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("wsgetRecord_args(");
      boolean first = true;

      sb.append("sentences:");
      if (this.sentences == null) {
        sb.append("null");
      } else {
        sb.append(this.sentences);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class wsgetRecord_result implements TBase<wsgetRecord_result, wsgetRecord_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("wsgetRecord_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField EX_FIELD_DESC = new TField("ex", TType.STRUCT, (short)1);
    private static final TField EX2_FIELD_DESC = new TField("ex2", TType.STRUCT, (short)2);

    public Record success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      EX((short)1, "ex"),
      EX2((short)2, "ex2");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // EX
            return EX;
          case 2: // EX2
            return EX2;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.EX, new FieldMetaData("ex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.EX2, new FieldMetaData("ex2", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(wsgetRecord_result.class, metaDataMap);
    }

    public wsgetRecord_result() {
    }

    public wsgetRecord_result(
      Record success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2)
    {
      this();
      this.success = success;
      this.ex = ex;
      this.ex2 = ex2;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public wsgetRecord_result(wsgetRecord_result other) {
      if (other.isSetSuccess()) {
        this.success = new Record(other.success);
      }
      if (other.isSetEx()) {
        this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.ex);
      }
      if (other.isSetEx2()) {
        this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.ex2);
      }
    }

    public wsgetRecord_result deepCopy() {
      return new wsgetRecord_result(this);
    }

    @Deprecated
    public wsgetRecord_result clone() {
      return new wsgetRecord_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.ex = null;
      this.ex2 = null;
    }

    public Record getSuccess() {
      return this.success;
    }

    public wsgetRecord_result setSuccess(Record success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getEx() {
      return this.ex;
    }

    public wsgetRecord_result setEx(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
      this.ex = ex;
      return this;
    }

    public void unsetEx() {
      this.ex = null;
    }

    /** Returns true if field ex is set (has been asigned a value) and false otherwise */
    public boolean isSetEx() {
      return this.ex != null;
    }

    public void setExIsSet(boolean value) {
      if (!value) {
        this.ex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getEx2() {
      return this.ex2;
    }

    public wsgetRecord_result setEx2(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
      this.ex2 = ex2;
      return this;
    }

    public void unsetEx2() {
      this.ex2 = null;
    }

    /** Returns true if field ex2 is set (has been asigned a value) and false otherwise */
    public boolean isSetEx2() {
      return this.ex2 != null;
    }

    public void setEx2IsSet(boolean value) {
      if (!value) {
        this.ex2 = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Record)value);
        }
        break;

      case EX:
        if (value == null) {
          unsetEx();
        } else {
          setEx((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case EX2:
        if (value == null) {
          unsetEx2();
        } else {
          setEx2((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case EX:
        return getEx();

      case EX2:
        return getEx2();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case EX:
        return isSetEx();
      case EX2:
        return isSetEx2();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof wsgetRecord_result)
        return this.equals((wsgetRecord_result)that);
      return false;
    }

    public boolean equals(wsgetRecord_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_ex = true && this.isSetEx();
      boolean that_present_ex = true && that.isSetEx();
      if (this_present_ex || that_present_ex) {
        if (!(this_present_ex && that_present_ex))
          return false;
        if (!this.ex.equals(that.ex))
          return false;
      }

      boolean this_present_ex2 = true && this.isSetEx2();
      boolean that_present_ex2 = true && that.isSetEx2();
      if (this_present_ex2 || that_present_ex2) {
        if (!(this_present_ex2 && that_present_ex2))
          return false;
        if (!this.ex2.equals(that.ex2))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_ex = true && (isSetEx());
      builder.append(present_ex);
      if (present_ex)
        builder.append(ex);

      boolean present_ex2 = true && (isSetEx2());
      builder.append(present_ex2);
      if (present_ex2)
        builder.append(ex2);

      return builder.toHashCode();
    }

    public int compareTo(wsgetRecord_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      wsgetRecord_result typedOther = (wsgetRecord_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx()).compareTo(typedOther.isSetEx());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx()) {        lastComparison = TBaseHelper.compareTo(this.ex, typedOther.ex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx2()).compareTo(typedOther.isSetEx2());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx2()) {        lastComparison = TBaseHelper.compareTo(this.ex2, typedOther.ex2);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new Record();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // EX
            if (field.type == TType.STRUCT) {
              this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.ex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // EX2
            if (field.type == TType.STRUCT) {
              this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.ex2.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx()) {
        oprot.writeFieldBegin(EX_FIELD_DESC);
        this.ex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx2()) {
        oprot.writeFieldBegin(EX2_FIELD_DESC);
        this.ex2.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("wsgetRecord_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex:");
      if (this.ex == null) {
        sb.append("null");
      } else {
        sb.append(this.ex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex2:");
      if (this.ex2 == null) {
        sb.append("null");
      } else {
        sb.append(this.ex2);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getRecordById_args implements TBase<getRecordById_args, getRecordById_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getRecordById_args");

    private static final TField IDENTIFIER_FIELD_DESC = new TField("identifier", TType.STRING, (short)1);

    public String identifier;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      IDENTIFIER((short)1, "identifier");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // IDENTIFIER
            return IDENTIFIER;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.IDENTIFIER, new FieldMetaData("identifier", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getRecordById_args.class, metaDataMap);
    }

    public getRecordById_args() {
    }

    public getRecordById_args(
      String identifier)
    {
      this();
      this.identifier = identifier;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getRecordById_args(getRecordById_args other) {
      if (other.isSetIdentifier()) {
        this.identifier = other.identifier;
      }
    }

    public getRecordById_args deepCopy() {
      return new getRecordById_args(this);
    }

    @Deprecated
    public getRecordById_args clone() {
      return new getRecordById_args(this);
    }

    @Override
    public void clear() {
      this.identifier = null;
    }

    public String getIdentifier() {
      return this.identifier;
    }

    public getRecordById_args setIdentifier(String identifier) {
      this.identifier = identifier;
      return this;
    }

    public void unsetIdentifier() {
      this.identifier = null;
    }

    /** Returns true if field identifier is set (has been asigned a value) and false otherwise */
    public boolean isSetIdentifier() {
      return this.identifier != null;
    }

    public void setIdentifierIsSet(boolean value) {
      if (!value) {
        this.identifier = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case IDENTIFIER:
        if (value == null) {
          unsetIdentifier();
        } else {
          setIdentifier((String)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case IDENTIFIER:
        return getIdentifier();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case IDENTIFIER:
        return isSetIdentifier();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getRecordById_args)
        return this.equals((getRecordById_args)that);
      return false;
    }

    public boolean equals(getRecordById_args that) {
      if (that == null)
        return false;

      boolean this_present_identifier = true && this.isSetIdentifier();
      boolean that_present_identifier = true && that.isSetIdentifier();
      if (this_present_identifier || that_present_identifier) {
        if (!(this_present_identifier && that_present_identifier))
          return false;
        if (!this.identifier.equals(that.identifier))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_identifier = true && (isSetIdentifier());
      builder.append(present_identifier);
      if (present_identifier)
        builder.append(identifier);

      return builder.toHashCode();
    }

    public int compareTo(getRecordById_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getRecordById_args typedOther = (getRecordById_args)other;

      lastComparison = Boolean.valueOf(isSetIdentifier()).compareTo(typedOther.isSetIdentifier());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetIdentifier()) {        lastComparison = TBaseHelper.compareTo(this.identifier, typedOther.identifier);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // IDENTIFIER
            if (field.type == TType.STRING) {
              this.identifier = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.identifier != null) {
        oprot.writeFieldBegin(IDENTIFIER_FIELD_DESC);
        oprot.writeString(this.identifier);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getRecordById_args(");
      boolean first = true;

      sb.append("identifier:");
      if (this.identifier == null) {
        sb.append("null");
      } else {
        sb.append(this.identifier);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getRecordById_result implements TBase<getRecordById_result, getRecordById_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getRecordById_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField EX_FIELD_DESC = new TField("ex", TType.STRUCT, (short)1);
    private static final TField EX2_FIELD_DESC = new TField("ex2", TType.STRUCT, (short)2);

    public Record success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      EX((short)1, "ex"),
      EX2((short)2, "ex2");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // EX
            return EX;
          case 2: // EX2
            return EX2;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      tmpMap.put(_Fields.EX, new FieldMetaData("ex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.EX2, new FieldMetaData("ex2", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getRecordById_result.class, metaDataMap);
    }

    public getRecordById_result() {
    }

    public getRecordById_result(
      Record success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2)
    {
      this();
      this.success = success;
      this.ex = ex;
      this.ex2 = ex2;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getRecordById_result(getRecordById_result other) {
      if (other.isSetSuccess()) {
        this.success = new Record(other.success);
      }
      if (other.isSetEx()) {
        this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.ex);
      }
      if (other.isSetEx2()) {
        this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.ex2);
      }
    }

    public getRecordById_result deepCopy() {
      return new getRecordById_result(this);
    }

    @Deprecated
    public getRecordById_result clone() {
      return new getRecordById_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.ex = null;
      this.ex2 = null;
    }

    public Record getSuccess() {
      return this.success;
    }

    public getRecordById_result setSuccess(Record success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getEx() {
      return this.ex;
    }

    public getRecordById_result setEx(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
      this.ex = ex;
      return this;
    }

    public void unsetEx() {
      this.ex = null;
    }

    /** Returns true if field ex is set (has been asigned a value) and false otherwise */
    public boolean isSetEx() {
      return this.ex != null;
    }

    public void setExIsSet(boolean value) {
      if (!value) {
        this.ex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getEx2() {
      return this.ex2;
    }

    public getRecordById_result setEx2(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
      this.ex2 = ex2;
      return this;
    }

    public void unsetEx2() {
      this.ex2 = null;
    }

    /** Returns true if field ex2 is set (has been asigned a value) and false otherwise */
    public boolean isSetEx2() {
      return this.ex2 != null;
    }

    public void setEx2IsSet(boolean value) {
      if (!value) {
        this.ex2 = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((Record)value);
        }
        break;

      case EX:
        if (value == null) {
          unsetEx();
        } else {
          setEx((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case EX2:
        if (value == null) {
          unsetEx2();
        } else {
          setEx2((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case EX:
        return getEx();

      case EX2:
        return getEx2();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case EX:
        return isSetEx();
      case EX2:
        return isSetEx2();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getRecordById_result)
        return this.equals((getRecordById_result)that);
      return false;
    }

    public boolean equals(getRecordById_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_ex = true && this.isSetEx();
      boolean that_present_ex = true && that.isSetEx();
      if (this_present_ex || that_present_ex) {
        if (!(this_present_ex && that_present_ex))
          return false;
        if (!this.ex.equals(that.ex))
          return false;
      }

      boolean this_present_ex2 = true && this.isSetEx2();
      boolean that_present_ex2 = true && that.isSetEx2();
      if (this_present_ex2 || that_present_ex2) {
        if (!(this_present_ex2 && that_present_ex2))
          return false;
        if (!this.ex2.equals(that.ex2))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_ex = true && (isSetEx());
      builder.append(present_ex);
      if (present_ex)
        builder.append(ex);

      boolean present_ex2 = true && (isSetEx2());
      builder.append(present_ex2);
      if (present_ex2)
        builder.append(ex2);

      return builder.toHashCode();
    }

    public int compareTo(getRecordById_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getRecordById_result typedOther = (getRecordById_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx()).compareTo(typedOther.isSetEx());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx()) {        lastComparison = TBaseHelper.compareTo(this.ex, typedOther.ex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx2()).compareTo(typedOther.isSetEx2());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx2()) {        lastComparison = TBaseHelper.compareTo(this.ex2, typedOther.ex2);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new Record();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // EX
            if (field.type == TType.STRUCT) {
              this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.ex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // EX2
            if (field.type == TType.STRUCT) {
              this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.ex2.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx()) {
        oprot.writeFieldBegin(EX_FIELD_DESC);
        this.ex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx2()) {
        oprot.writeFieldBegin(EX2_FIELD_DESC);
        this.ex2.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getRecordById_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex:");
      if (this.ex == null) {
        sb.append("null");
      } else {
        sb.append(this.ex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex2:");
      if (this.ex2 == null) {
        sb.append("null");
      } else {
        sb.append(this.ex2);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class storeRecord_args implements TBase<storeRecord_args, storeRecord_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("storeRecord_args");

    private static final TField RECORD_FIELD_DESC = new TField("record", TType.STRUCT, (short)1);

    public Record record;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      RECORD((short)1, "record");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // RECORD
            return RECORD;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.RECORD, new FieldMetaData("record", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, Record.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(storeRecord_args.class, metaDataMap);
    }

    public storeRecord_args() {
    }

    public storeRecord_args(
      Record record)
    {
      this();
      this.record = record;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public storeRecord_args(storeRecord_args other) {
      if (other.isSetRecord()) {
        this.record = new Record(other.record);
      }
    }

    public storeRecord_args deepCopy() {
      return new storeRecord_args(this);
    }

    @Deprecated
    public storeRecord_args clone() {
      return new storeRecord_args(this);
    }

    @Override
    public void clear() {
      this.record = null;
    }

    public Record getRecord() {
      return this.record;
    }

    public storeRecord_args setRecord(Record record) {
      this.record = record;
      return this;
    }

    public void unsetRecord() {
      this.record = null;
    }

    /** Returns true if field record is set (has been asigned a value) and false otherwise */
    public boolean isSetRecord() {
      return this.record != null;
    }

    public void setRecordIsSet(boolean value) {
      if (!value) {
        this.record = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case RECORD:
        if (value == null) {
          unsetRecord();
        } else {
          setRecord((Record)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case RECORD:
        return getRecord();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case RECORD:
        return isSetRecord();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof storeRecord_args)
        return this.equals((storeRecord_args)that);
      return false;
    }

    public boolean equals(storeRecord_args that) {
      if (that == null)
        return false;

      boolean this_present_record = true && this.isSetRecord();
      boolean that_present_record = true && that.isSetRecord();
      if (this_present_record || that_present_record) {
        if (!(this_present_record && that_present_record))
          return false;
        if (!this.record.equals(that.record))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_record = true && (isSetRecord());
      builder.append(present_record);
      if (present_record)
        builder.append(record);

      return builder.toHashCode();
    }

    public int compareTo(storeRecord_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      storeRecord_args typedOther = (storeRecord_args)other;

      lastComparison = Boolean.valueOf(isSetRecord()).compareTo(typedOther.isSetRecord());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRecord()) {        lastComparison = TBaseHelper.compareTo(this.record, typedOther.record);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // RECORD
            if (field.type == TType.STRUCT) {
              this.record = new Record();
              this.record.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.record != null) {
        oprot.writeFieldBegin(RECORD_FIELD_DESC);
        this.record.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("storeRecord_args(");
      boolean first = true;

      sb.append("record:");
      if (this.record == null) {
        sb.append("null");
      } else {
        sb.append(this.record);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class storeRecord_result implements TBase<storeRecord_result, storeRecord_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("storeRecord_result");

    private static final TField SSEX_FIELD_DESC = new TField("ssex", TType.STRUCT, (short)1);

    public edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SSEX((short)1, "ssex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // SSEX
            return SSEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SSEX, new FieldMetaData("ssex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(storeRecord_result.class, metaDataMap);
    }

    public storeRecord_result() {
    }

    public storeRecord_result(
      edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex)
    {
      this();
      this.ssex = ssex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public storeRecord_result(storeRecord_result other) {
      if (other.isSetSsex()) {
        this.ssex = new edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException(other.ssex);
      }
    }

    public storeRecord_result deepCopy() {
      return new storeRecord_result(this);
    }

    @Deprecated
    public storeRecord_result clone() {
      return new storeRecord_result(this);
    }

    @Override
    public void clear() {
      this.ssex = null;
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException getSsex() {
      return this.ssex;
    }

    public storeRecord_result setSsex(edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex) {
      this.ssex = ssex;
      return this;
    }

    public void unsetSsex() {
      this.ssex = null;
    }

    /** Returns true if field ssex is set (has been asigned a value) and false otherwise */
    public boolean isSetSsex() {
      return this.ssex != null;
    }

    public void setSsexIsSet(boolean value) {
      if (!value) {
        this.ssex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SSEX:
        if (value == null) {
          unsetSsex();
        } else {
          setSsex((edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SSEX:
        return getSsex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SSEX:
        return isSetSsex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof storeRecord_result)
        return this.equals((storeRecord_result)that);
      return false;
    }

    public boolean equals(storeRecord_result that) {
      if (that == null)
        return false;

      boolean this_present_ssex = true && this.isSetSsex();
      boolean that_present_ssex = true && that.isSetSsex();
      if (this_present_ssex || that_present_ssex) {
        if (!(this_present_ssex && that_present_ssex))
          return false;
        if (!this.ssex.equals(that.ssex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_ssex = true && (isSetSsex());
      builder.append(present_ssex);
      if (present_ssex)
        builder.append(ssex);

      return builder.toHashCode();
    }

    public int compareTo(storeRecord_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      storeRecord_result typedOther = (storeRecord_result)other;

      lastComparison = Boolean.valueOf(isSetSsex()).compareTo(typedOther.isSetSsex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSsex()) {        lastComparison = TBaseHelper.compareTo(this.ssex, typedOther.ssex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // SSEX
            if (field.type == TType.STRUCT) {
              this.ssex = new edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException();
              this.ssex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSsex()) {
        oprot.writeFieldBegin(SSEX_FIELD_DESC);
        this.ssex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("storeRecord_result(");
      boolean first = true;

      sb.append("ssex:");
      if (this.ssex == null) {
        sb.append("null");
      } else {
        sb.append(this.ssex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getMultiRecord_args implements TBase<getMultiRecord_args, getMultiRecord_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getMultiRecord_args");

    private static final TField TEXTS_FIELD_DESC = new TField("texts", TType.LIST, (short)1);

    public List<String> texts;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      TEXTS((short)1, "texts");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // TEXTS
            return TEXTS;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.TEXTS, new FieldMetaData("texts", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new FieldValueMetaData(TType.STRING))));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getMultiRecord_args.class, metaDataMap);
    }

    public getMultiRecord_args() {
    }

    public getMultiRecord_args(
      List<String> texts)
    {
      this();
      this.texts = texts;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getMultiRecord_args(getMultiRecord_args other) {
      if (other.isSetTexts()) {
        List<String> __this__texts = new ArrayList<String>();
        for (String other_element : other.texts) {
          __this__texts.add(other_element);
        }
        this.texts = __this__texts;
      }
    }

    public getMultiRecord_args deepCopy() {
      return new getMultiRecord_args(this);
    }

    @Deprecated
    public getMultiRecord_args clone() {
      return new getMultiRecord_args(this);
    }

    @Override
    public void clear() {
      this.texts = null;
    }

    public int getTextsSize() {
      return (this.texts == null) ? 0 : this.texts.size();
    }

    public java.util.Iterator<String> getTextsIterator() {
      return (this.texts == null) ? null : this.texts.iterator();
    }

    public void addToTexts(String elem) {
      if (this.texts == null) {
        this.texts = new ArrayList<String>();
      }
      this.texts.add(elem);
    }

    public List<String> getTexts() {
      return this.texts;
    }

    public getMultiRecord_args setTexts(List<String> texts) {
      this.texts = texts;
      return this;
    }

    public void unsetTexts() {
      this.texts = null;
    }

    /** Returns true if field texts is set (has been asigned a value) and false otherwise */
    public boolean isSetTexts() {
      return this.texts != null;
    }

    public void setTextsIsSet(boolean value) {
      if (!value) {
        this.texts = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case TEXTS:
        if (value == null) {
          unsetTexts();
        } else {
          setTexts((List<String>)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case TEXTS:
        return getTexts();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case TEXTS:
        return isSetTexts();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getMultiRecord_args)
        return this.equals((getMultiRecord_args)that);
      return false;
    }

    public boolean equals(getMultiRecord_args that) {
      if (that == null)
        return false;

      boolean this_present_texts = true && this.isSetTexts();
      boolean that_present_texts = true && that.isSetTexts();
      if (this_present_texts || that_present_texts) {
        if (!(this_present_texts && that_present_texts))
          return false;
        if (!this.texts.equals(that.texts))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_texts = true && (isSetTexts());
      builder.append(present_texts);
      if (present_texts)
        builder.append(texts);

      return builder.toHashCode();
    }

    public int compareTo(getMultiRecord_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getMultiRecord_args typedOther = (getMultiRecord_args)other;

      lastComparison = Boolean.valueOf(isSetTexts()).compareTo(typedOther.isSetTexts());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetTexts()) {        lastComparison = TBaseHelper.compareTo(this.texts, typedOther.texts);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // TEXTS
            if (field.type == TType.LIST) {
              {
                TList _list57 = iprot.readListBegin();
                this.texts = new ArrayList<String>(_list57.size);
                for (int _i58 = 0; _i58 < _list57.size; ++_i58)
                {
                  String _elem59;
                  _elem59 = iprot.readString();
                  this.texts.add(_elem59);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.texts != null) {
        oprot.writeFieldBegin(TEXTS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRING, this.texts.size()));
          for (String _iter60 : this.texts)
          {
            oprot.writeString(_iter60);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getMultiRecord_args(");
      boolean first = true;

      sb.append("texts:");
      if (this.texts == null) {
        sb.append("null");
      } else {
        sb.append(this.texts);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class getMultiRecord_result implements TBase<getMultiRecord_result, getMultiRecord_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("getMultiRecord_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField EX_FIELD_DESC = new TField("ex", TType.STRUCT, (short)1);
    private static final TField EX2_FIELD_DESC = new TField("ex2", TType.STRUCT, (short)2);

    public MultiRecord success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      EX((short)1, "ex"),
      EX2((short)2, "ex2");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // EX
            return EX;
          case 2: // EX2
            return EX2;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, MultiRecord.class)));
      tmpMap.put(_Fields.EX, new FieldMetaData("ex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.EX2, new FieldMetaData("ex2", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(getMultiRecord_result.class, metaDataMap);
    }

    public getMultiRecord_result() {
    }

    public getMultiRecord_result(
      MultiRecord success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2)
    {
      this();
      this.success = success;
      this.ex = ex;
      this.ex2 = ex2;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public getMultiRecord_result(getMultiRecord_result other) {
      if (other.isSetSuccess()) {
        this.success = new MultiRecord(other.success);
      }
      if (other.isSetEx()) {
        this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.ex);
      }
      if (other.isSetEx2()) {
        this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.ex2);
      }
    }

    public getMultiRecord_result deepCopy() {
      return new getMultiRecord_result(this);
    }

    @Deprecated
    public getMultiRecord_result clone() {
      return new getMultiRecord_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.ex = null;
      this.ex2 = null;
    }

    public MultiRecord getSuccess() {
      return this.success;
    }

    public getMultiRecord_result setSuccess(MultiRecord success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getEx() {
      return this.ex;
    }

    public getMultiRecord_result setEx(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException ex) {
      this.ex = ex;
      return this;
    }

    public void unsetEx() {
      this.ex = null;
    }

    /** Returns true if field ex is set (has been asigned a value) and false otherwise */
    public boolean isSetEx() {
      return this.ex != null;
    }

    public void setExIsSet(boolean value) {
      if (!value) {
        this.ex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getEx2() {
      return this.ex2;
    }

    public getMultiRecord_result setEx2(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException ex2) {
      this.ex2 = ex2;
      return this;
    }

    public void unsetEx2() {
      this.ex2 = null;
    }

    /** Returns true if field ex2 is set (has been asigned a value) and false otherwise */
    public boolean isSetEx2() {
      return this.ex2 != null;
    }

    public void setEx2IsSet(boolean value) {
      if (!value) {
        this.ex2 = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((MultiRecord)value);
        }
        break;

      case EX:
        if (value == null) {
          unsetEx();
        } else {
          setEx((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case EX2:
        if (value == null) {
          unsetEx2();
        } else {
          setEx2((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case EX:
        return getEx();

      case EX2:
        return getEx2();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case EX:
        return isSetEx();
      case EX2:
        return isSetEx2();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof getMultiRecord_result)
        return this.equals((getMultiRecord_result)that);
      return false;
    }

    public boolean equals(getMultiRecord_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_ex = true && this.isSetEx();
      boolean that_present_ex = true && that.isSetEx();
      if (this_present_ex || that_present_ex) {
        if (!(this_present_ex && that_present_ex))
          return false;
        if (!this.ex.equals(that.ex))
          return false;
      }

      boolean this_present_ex2 = true && this.isSetEx2();
      boolean that_present_ex2 = true && that.isSetEx2();
      if (this_present_ex2 || that_present_ex2) {
        if (!(this_present_ex2 && that_present_ex2))
          return false;
        if (!this.ex2.equals(that.ex2))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_ex = true && (isSetEx());
      builder.append(present_ex);
      if (present_ex)
        builder.append(ex);

      boolean present_ex2 = true && (isSetEx2());
      builder.append(present_ex2);
      if (present_ex2)
        builder.append(ex2);

      return builder.toHashCode();
    }

    public int compareTo(getMultiRecord_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      getMultiRecord_result typedOther = (getMultiRecord_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx()).compareTo(typedOther.isSetEx());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx()) {        lastComparison = TBaseHelper.compareTo(this.ex, typedOther.ex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetEx2()).compareTo(typedOther.isSetEx2());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetEx2()) {        lastComparison = TBaseHelper.compareTo(this.ex2, typedOther.ex2);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new MultiRecord();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // EX
            if (field.type == TType.STRUCT) {
              this.ex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.ex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // EX2
            if (field.type == TType.STRUCT) {
              this.ex2 = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.ex2.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx()) {
        oprot.writeFieldBegin(EX_FIELD_DESC);
        this.ex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetEx2()) {
        oprot.writeFieldBegin(EX2_FIELD_DESC);
        this.ex2.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("getMultiRecord_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex:");
      if (this.ex == null) {
        sb.append("null");
      } else {
        sb.append(this.ex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("ex2:");
      if (this.ex2 == null) {
        sb.append("null");
      } else {
        sb.append(this.ex2);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class provideMulti_args implements TBase<provideMulti_args, provideMulti_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("provideMulti_args");

    private static final TField VIEW_NAME_FIELD_DESC = new TField("view_name", TType.STRING, (short)1);
    private static final TField TEXTS_FIELD_DESC = new TField("texts", TType.LIST, (short)2);
    private static final TField FORCE_UPDATE_FIELD_DESC = new TField("forceUpdate", TType.BOOL, (short)3);

    public String view_name;
    public List<String> texts;
    public boolean forceUpdate;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      VIEW_NAME((short)1, "view_name"),
      TEXTS((short)2, "texts"),
      FORCE_UPDATE((short)3, "forceUpdate");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // VIEW_NAME
            return VIEW_NAME;
          case 2: // TEXTS
            return TEXTS;
          case 3: // FORCE_UPDATE
            return FORCE_UPDATE;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments
    private static final int __FORCEUPDATE_ISSET_ID = 0;
    private BitSet __isset_bit_vector = new BitSet(1);

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.VIEW_NAME, new FieldMetaData("view_name", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRING)));
      tmpMap.put(_Fields.TEXTS, new FieldMetaData("texts", TFieldRequirementType.DEFAULT, 
          new ListMetaData(TType.LIST, 
              new FieldValueMetaData(TType.STRING))));
      tmpMap.put(_Fields.FORCE_UPDATE, new FieldMetaData("forceUpdate", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.BOOL)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(provideMulti_args.class, metaDataMap);
    }

    public provideMulti_args() {
    }

    public provideMulti_args(
      String view_name,
      List<String> texts,
      boolean forceUpdate)
    {
      this();
      this.view_name = view_name;
      this.texts = texts;
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public provideMulti_args(provideMulti_args other) {
      __isset_bit_vector.clear();
      __isset_bit_vector.or(other.__isset_bit_vector);
      if (other.isSetView_name()) {
        this.view_name = other.view_name;
      }
      if (other.isSetTexts()) {
        List<String> __this__texts = new ArrayList<String>();
        for (String other_element : other.texts) {
          __this__texts.add(other_element);
        }
        this.texts = __this__texts;
      }
      this.forceUpdate = other.forceUpdate;
    }

    public provideMulti_args deepCopy() {
      return new provideMulti_args(this);
    }

    @Deprecated
    public provideMulti_args clone() {
      return new provideMulti_args(this);
    }

    @Override
    public void clear() {
      this.view_name = null;
      this.texts = null;
      setForceUpdateIsSet(false);
      this.forceUpdate = false;
    }

    public String getView_name() {
      return this.view_name;
    }

    public provideMulti_args setView_name(String view_name) {
      this.view_name = view_name;
      return this;
    }

    public void unsetView_name() {
      this.view_name = null;
    }

    /** Returns true if field view_name is set (has been asigned a value) and false otherwise */
    public boolean isSetView_name() {
      return this.view_name != null;
    }

    public void setView_nameIsSet(boolean value) {
      if (!value) {
        this.view_name = null;
      }
    }

    public int getTextsSize() {
      return (this.texts == null) ? 0 : this.texts.size();
    }

    public java.util.Iterator<String> getTextsIterator() {
      return (this.texts == null) ? null : this.texts.iterator();
    }

    public void addToTexts(String elem) {
      if (this.texts == null) {
        this.texts = new ArrayList<String>();
      }
      this.texts.add(elem);
    }

    public List<String> getTexts() {
      return this.texts;
    }

    public provideMulti_args setTexts(List<String> texts) {
      this.texts = texts;
      return this;
    }

    public void unsetTexts() {
      this.texts = null;
    }

    /** Returns true if field texts is set (has been asigned a value) and false otherwise */
    public boolean isSetTexts() {
      return this.texts != null;
    }

    public void setTextsIsSet(boolean value) {
      if (!value) {
        this.texts = null;
      }
    }

    public boolean isForceUpdate() {
      return this.forceUpdate;
    }

    public provideMulti_args setForceUpdate(boolean forceUpdate) {
      this.forceUpdate = forceUpdate;
      setForceUpdateIsSet(true);
      return this;
    }

    public void unsetForceUpdate() {
      __isset_bit_vector.clear(__FORCEUPDATE_ISSET_ID);
    }

    /** Returns true if field forceUpdate is set (has been asigned a value) and false otherwise */
    public boolean isSetForceUpdate() {
      return __isset_bit_vector.get(__FORCEUPDATE_ISSET_ID);
    }

    public void setForceUpdateIsSet(boolean value) {
      __isset_bit_vector.set(__FORCEUPDATE_ISSET_ID, value);
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case VIEW_NAME:
        if (value == null) {
          unsetView_name();
        } else {
          setView_name((String)value);
        }
        break;

      case TEXTS:
        if (value == null) {
          unsetTexts();
        } else {
          setTexts((List<String>)value);
        }
        break;

      case FORCE_UPDATE:
        if (value == null) {
          unsetForceUpdate();
        } else {
          setForceUpdate((Boolean)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return getView_name();

      case TEXTS:
        return getTexts();

      case FORCE_UPDATE:
        return new Boolean(isForceUpdate());

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case VIEW_NAME:
        return isSetView_name();
      case TEXTS:
        return isSetTexts();
      case FORCE_UPDATE:
        return isSetForceUpdate();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof provideMulti_args)
        return this.equals((provideMulti_args)that);
      return false;
    }

    public boolean equals(provideMulti_args that) {
      if (that == null)
        return false;

      boolean this_present_view_name = true && this.isSetView_name();
      boolean that_present_view_name = true && that.isSetView_name();
      if (this_present_view_name || that_present_view_name) {
        if (!(this_present_view_name && that_present_view_name))
          return false;
        if (!this.view_name.equals(that.view_name))
          return false;
      }

      boolean this_present_texts = true && this.isSetTexts();
      boolean that_present_texts = true && that.isSetTexts();
      if (this_present_texts || that_present_texts) {
        if (!(this_present_texts && that_present_texts))
          return false;
        if (!this.texts.equals(that.texts))
          return false;
      }

      boolean this_present_forceUpdate = true;
      boolean that_present_forceUpdate = true;
      if (this_present_forceUpdate || that_present_forceUpdate) {
        if (!(this_present_forceUpdate && that_present_forceUpdate))
          return false;
        if (this.forceUpdate != that.forceUpdate)
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_view_name = true && (isSetView_name());
      builder.append(present_view_name);
      if (present_view_name)
        builder.append(view_name);

      boolean present_texts = true && (isSetTexts());
      builder.append(present_texts);
      if (present_texts)
        builder.append(texts);

      boolean present_forceUpdate = true;
      builder.append(present_forceUpdate);
      if (present_forceUpdate)
        builder.append(forceUpdate);

      return builder.toHashCode();
    }

    public int compareTo(provideMulti_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      provideMulti_args typedOther = (provideMulti_args)other;

      lastComparison = Boolean.valueOf(isSetView_name()).compareTo(typedOther.isSetView_name());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetView_name()) {        lastComparison = TBaseHelper.compareTo(this.view_name, typedOther.view_name);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetTexts()).compareTo(typedOther.isSetTexts());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetTexts()) {        lastComparison = TBaseHelper.compareTo(this.texts, typedOther.texts);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetForceUpdate()).compareTo(typedOther.isSetForceUpdate());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetForceUpdate()) {        lastComparison = TBaseHelper.compareTo(this.forceUpdate, typedOther.forceUpdate);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // VIEW_NAME
            if (field.type == TType.STRING) {
              this.view_name = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // TEXTS
            if (field.type == TType.LIST) {
              {
                TList _list61 = iprot.readListBegin();
                this.texts = new ArrayList<String>(_list61.size);
                for (int _i62 = 0; _i62 < _list61.size; ++_i62)
                {
                  String _elem63;
                  _elem63 = iprot.readString();
                  this.texts.add(_elem63);
                }
                iprot.readListEnd();
              }
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 3: // FORCE_UPDATE
            if (field.type == TType.BOOL) {
              this.forceUpdate = iprot.readBool();
              setForceUpdateIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.view_name != null) {
        oprot.writeFieldBegin(VIEW_NAME_FIELD_DESC);
        oprot.writeString(this.view_name);
        oprot.writeFieldEnd();
      }
      if (this.texts != null) {
        oprot.writeFieldBegin(TEXTS_FIELD_DESC);
        {
          oprot.writeListBegin(new TList(TType.STRING, this.texts.size()));
          for (String _iter64 : this.texts)
          {
            oprot.writeString(_iter64);
          }
          oprot.writeListEnd();
        }
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(FORCE_UPDATE_FIELD_DESC);
      oprot.writeBool(this.forceUpdate);
      oprot.writeFieldEnd();
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("provideMulti_args(");
      boolean first = true;

      sb.append("view_name:");
      if (this.view_name == null) {
        sb.append("null");
      } else {
        sb.append(this.view_name);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("texts:");
      if (this.texts == null) {
        sb.append("null");
      } else {
        sb.append(this.texts);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("forceUpdate:");
      sb.append(this.forceUpdate);
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class provideMulti_result implements TBase<provideMulti_result, provideMulti_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("provideMulti_result");

    private static final TField SUCCESS_FIELD_DESC = new TField("success", TType.STRUCT, (short)0);
    private static final TField SUEX_FIELD_DESC = new TField("suex", TType.STRUCT, (short)1);
    private static final TField AFEX_FIELD_DESC = new TField("afex", TType.STRUCT, (short)2);

    public MultiRecord success;
    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex;
    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SUCCESS((short)0, "success"),
      SUEX((short)1, "suex"),
      AFEX((short)2, "afex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 0: // SUCCESS
            return SUCCESS;
          case 1: // SUEX
            return SUEX;
          case 2: // AFEX
            return AFEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SUCCESS, new FieldMetaData("success", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, MultiRecord.class)));
      tmpMap.put(_Fields.SUEX, new FieldMetaData("suex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      tmpMap.put(_Fields.AFEX, new FieldMetaData("afex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(provideMulti_result.class, metaDataMap);
    }

    public provideMulti_result() {
    }

    public provideMulti_result(
      MultiRecord success,
      edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex,
      edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex)
    {
      this();
      this.success = success;
      this.suex = suex;
      this.afex = afex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public provideMulti_result(provideMulti_result other) {
      if (other.isSetSuccess()) {
        this.success = new MultiRecord(other.success);
      }
      if (other.isSetSuex()) {
        this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException(other.suex);
      }
      if (other.isSetAfex()) {
        this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException(other.afex);
      }
    }

    public provideMulti_result deepCopy() {
      return new provideMulti_result(this);
    }

    @Deprecated
    public provideMulti_result clone() {
      return new provideMulti_result(this);
    }

    @Override
    public void clear() {
      this.success = null;
      this.suex = null;
      this.afex = null;
    }

    public MultiRecord getSuccess() {
      return this.success;
    }

    public provideMulti_result setSuccess(MultiRecord success) {
      this.success = success;
      return this;
    }

    public void unsetSuccess() {
      this.success = null;
    }

    /** Returns true if field success is set (has been asigned a value) and false otherwise */
    public boolean isSetSuccess() {
      return this.success != null;
    }

    public void setSuccessIsSet(boolean value) {
      if (!value) {
        this.success = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException getSuex() {
      return this.suex;
    }

    public provideMulti_result setSuex(edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException suex) {
      this.suex = suex;
      return this;
    }

    public void unsetSuex() {
      this.suex = null;
    }

    /** Returns true if field suex is set (has been asigned a value) and false otherwise */
    public boolean isSetSuex() {
      return this.suex != null;
    }

    public void setSuexIsSet(boolean value) {
      if (!value) {
        this.suex = null;
      }
    }

    public edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException getAfex() {
      return this.afex;
    }

    public provideMulti_result setAfex(edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException afex) {
      this.afex = afex;
      return this;
    }

    public void unsetAfex() {
      this.afex = null;
    }

    /** Returns true if field afex is set (has been asigned a value) and false otherwise */
    public boolean isSetAfex() {
      return this.afex != null;
    }

    public void setAfexIsSet(boolean value) {
      if (!value) {
        this.afex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SUCCESS:
        if (value == null) {
          unsetSuccess();
        } else {
          setSuccess((MultiRecord)value);
        }
        break;

      case SUEX:
        if (value == null) {
          unsetSuex();
        } else {
          setSuex((edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException)value);
        }
        break;

      case AFEX:
        if (value == null) {
          unsetAfex();
        } else {
          setAfex((edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SUCCESS:
        return getSuccess();

      case SUEX:
        return getSuex();

      case AFEX:
        return getAfex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SUCCESS:
        return isSetSuccess();
      case SUEX:
        return isSetSuex();
      case AFEX:
        return isSetAfex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof provideMulti_result)
        return this.equals((provideMulti_result)that);
      return false;
    }

    public boolean equals(provideMulti_result that) {
      if (that == null)
        return false;

      boolean this_present_success = true && this.isSetSuccess();
      boolean that_present_success = true && that.isSetSuccess();
      if (this_present_success || that_present_success) {
        if (!(this_present_success && that_present_success))
          return false;
        if (!this.success.equals(that.success))
          return false;
      }

      boolean this_present_suex = true && this.isSetSuex();
      boolean that_present_suex = true && that.isSetSuex();
      if (this_present_suex || that_present_suex) {
        if (!(this_present_suex && that_present_suex))
          return false;
        if (!this.suex.equals(that.suex))
          return false;
      }

      boolean this_present_afex = true && this.isSetAfex();
      boolean that_present_afex = true && that.isSetAfex();
      if (this_present_afex || that_present_afex) {
        if (!(this_present_afex && that_present_afex))
          return false;
        if (!this.afex.equals(that.afex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_success = true && (isSetSuccess());
      builder.append(present_success);
      if (present_success)
        builder.append(success);

      boolean present_suex = true && (isSetSuex());
      builder.append(present_suex);
      if (present_suex)
        builder.append(suex);

      boolean present_afex = true && (isSetAfex());
      builder.append(present_afex);
      if (present_afex)
        builder.append(afex);

      return builder.toHashCode();
    }

    public int compareTo(provideMulti_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      provideMulti_result typedOther = (provideMulti_result)other;

      lastComparison = Boolean.valueOf(isSetSuccess()).compareTo(typedOther.isSetSuccess());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuccess()) {        lastComparison = TBaseHelper.compareTo(this.success, typedOther.success);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetSuex()).compareTo(typedOther.isSetSuex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSuex()) {        lastComparison = TBaseHelper.compareTo(this.suex, typedOther.suex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      lastComparison = Boolean.valueOf(isSetAfex()).compareTo(typedOther.isSetAfex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetAfex()) {        lastComparison = TBaseHelper.compareTo(this.afex, typedOther.afex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 0: // SUCCESS
            if (field.type == TType.STRUCT) {
              this.success = new MultiRecord();
              this.success.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 1: // SUEX
            if (field.type == TType.STRUCT) {
              this.suex = new edu.illinois.cs.cogcomp.thrift.base.ServiceUnavailableException();
              this.suex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case 2: // AFEX
            if (field.type == TType.STRUCT) {
              this.afex = new edu.illinois.cs.cogcomp.thrift.base.AnnotationFailedException();
              this.afex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSuccess()) {
        oprot.writeFieldBegin(SUCCESS_FIELD_DESC);
        this.success.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetSuex()) {
        oprot.writeFieldBegin(SUEX_FIELD_DESC);
        this.suex.write(oprot);
        oprot.writeFieldEnd();
      } else if (this.isSetAfex()) {
        oprot.writeFieldBegin(AFEX_FIELD_DESC);
        this.afex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("provideMulti_result(");
      boolean first = true;

      sb.append("success:");
      if (this.success == null) {
        sb.append("null");
      } else {
        sb.append(this.success);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("suex:");
      if (this.suex == null) {
        sb.append("null");
      } else {
        sb.append(this.suex);
      }
      first = false;
      if (!first) sb.append(", ");
      sb.append("afex:");
      if (this.afex == null) {
        sb.append("null");
      } else {
        sb.append(this.afex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class storeMultiRecord_args implements TBase<storeMultiRecord_args, storeMultiRecord_args._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("storeMultiRecord_args");

    private static final TField RECORD_FIELD_DESC = new TField("record", TType.STRUCT, (short)1);

    public MultiRecord record;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      RECORD((short)1, "record");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // RECORD
            return RECORD;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.RECORD, new FieldMetaData("record", TFieldRequirementType.DEFAULT, 
          new StructMetaData(TType.STRUCT, MultiRecord.class)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(storeMultiRecord_args.class, metaDataMap);
    }

    public storeMultiRecord_args() {
    }

    public storeMultiRecord_args(
      MultiRecord record)
    {
      this();
      this.record = record;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public storeMultiRecord_args(storeMultiRecord_args other) {
      if (other.isSetRecord()) {
        this.record = new MultiRecord(other.record);
      }
    }

    public storeMultiRecord_args deepCopy() {
      return new storeMultiRecord_args(this);
    }

    @Deprecated
    public storeMultiRecord_args clone() {
      return new storeMultiRecord_args(this);
    }

    @Override
    public void clear() {
      this.record = null;
    }

    public MultiRecord getRecord() {
      return this.record;
    }

    public storeMultiRecord_args setRecord(MultiRecord record) {
      this.record = record;
      return this;
    }

    public void unsetRecord() {
      this.record = null;
    }

    /** Returns true if field record is set (has been asigned a value) and false otherwise */
    public boolean isSetRecord() {
      return this.record != null;
    }

    public void setRecordIsSet(boolean value) {
      if (!value) {
        this.record = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case RECORD:
        if (value == null) {
          unsetRecord();
        } else {
          setRecord((MultiRecord)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case RECORD:
        return getRecord();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case RECORD:
        return isSetRecord();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof storeMultiRecord_args)
        return this.equals((storeMultiRecord_args)that);
      return false;
    }

    public boolean equals(storeMultiRecord_args that) {
      if (that == null)
        return false;

      boolean this_present_record = true && this.isSetRecord();
      boolean that_present_record = true && that.isSetRecord();
      if (this_present_record || that_present_record) {
        if (!(this_present_record && that_present_record))
          return false;
        if (!this.record.equals(that.record))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_record = true && (isSetRecord());
      builder.append(present_record);
      if (present_record)
        builder.append(record);

      return builder.toHashCode();
    }

    public int compareTo(storeMultiRecord_args other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      storeMultiRecord_args typedOther = (storeMultiRecord_args)other;

      lastComparison = Boolean.valueOf(isSetRecord()).compareTo(typedOther.isSetRecord());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetRecord()) {        lastComparison = TBaseHelper.compareTo(this.record, typedOther.record);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // RECORD
            if (field.type == TType.STRUCT) {
              this.record = new MultiRecord();
              this.record.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (this.record != null) {
        oprot.writeFieldBegin(RECORD_FIELD_DESC);
        this.record.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("storeMultiRecord_args(");
      boolean first = true;

      sb.append("record:");
      if (this.record == null) {
        sb.append("null");
      } else {
        sb.append(this.record);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

  public static class storeMultiRecord_result implements TBase<storeMultiRecord_result, storeMultiRecord_result._Fields>, java.io.Serializable, Cloneable   {
    private static final TStruct STRUCT_DESC = new TStruct("storeMultiRecord_result");

    private static final TField SSEX_FIELD_DESC = new TField("ssex", TType.STRUCT, (short)1);

    public edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex;

    /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
    public enum _Fields implements TFieldIdEnum {
      SSEX((short)1, "ssex");

      private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

      static {
        for (_Fields field : EnumSet.allOf(_Fields.class)) {
          byName.put(field.getFieldName(), field);
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, or null if its not found.
       */
      public static _Fields findByThriftId(int fieldId) {
        switch(fieldId) {
          case 1: // SSEX
            return SSEX;
          default:
            return null;
        }
      }

      /**
       * Find the _Fields constant that matches fieldId, throwing an exception
       * if it is not found.
       */
      public static _Fields findByThriftIdOrThrow(int fieldId) {
        _Fields fields = findByThriftId(fieldId);
        if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
        return fields;
      }

      /**
       * Find the _Fields constant that matches name, or null if its not found.
       */
      public static _Fields findByName(String name) {
        return byName.get(name);
      }

      private final short _thriftId;
      private final String _fieldName;

      _Fields(short thriftId, String fieldName) {
        _thriftId = thriftId;
        _fieldName = fieldName;
      }

      public short getThriftFieldId() {
        return _thriftId;
      }

      public String getFieldName() {
        return _fieldName;
      }
    }

    // isset id assignments

    public static final Map<_Fields, FieldMetaData> metaDataMap;
    static {
      Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
      tmpMap.put(_Fields.SSEX, new FieldMetaData("ssex", TFieldRequirementType.DEFAULT, 
          new FieldValueMetaData(TType.STRUCT)));
      metaDataMap = Collections.unmodifiableMap(tmpMap);
      FieldMetaData.addStructMetaDataMap(storeMultiRecord_result.class, metaDataMap);
    }

    public storeMultiRecord_result() {
    }

    public storeMultiRecord_result(
      edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex)
    {
      this();
      this.ssex = ssex;
    }

    /**
     * Performs a deep copy on <i>other</i>.
     */
    public storeMultiRecord_result(storeMultiRecord_result other) {
      if (other.isSetSsex()) {
        this.ssex = new edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException(other.ssex);
      }
    }

    public storeMultiRecord_result deepCopy() {
      return new storeMultiRecord_result(this);
    }

    @Deprecated
    public storeMultiRecord_result clone() {
      return new storeMultiRecord_result(this);
    }

    @Override
    public void clear() {
      this.ssex = null;
    }

    public edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException getSsex() {
      return this.ssex;
    }

    public storeMultiRecord_result setSsex(edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException ssex) {
      this.ssex = ssex;
      return this;
    }

    public void unsetSsex() {
      this.ssex = null;
    }

    /** Returns true if field ssex is set (has been asigned a value) and false otherwise */
    public boolean isSetSsex() {
      return this.ssex != null;
    }

    public void setSsexIsSet(boolean value) {
      if (!value) {
        this.ssex = null;
      }
    }

    public void setFieldValue(_Fields field, Object value) {
      switch (field) {
      case SSEX:
        if (value == null) {
          unsetSsex();
        } else {
          setSsex((edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException)value);
        }
        break;

      }
    }

    public void setFieldValue(int fieldID, Object value) {
      setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
    }

    public Object getFieldValue(_Fields field) {
      switch (field) {
      case SSEX:
        return getSsex();

      }
      throw new IllegalStateException();
    }

    public Object getFieldValue(int fieldId) {
      return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
    }

    /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
    public boolean isSet(_Fields field) {
      switch (field) {
      case SSEX:
        return isSetSsex();
      }
      throw new IllegalStateException();
    }

    public boolean isSet(int fieldID) {
      return isSet(_Fields.findByThriftIdOrThrow(fieldID));
    }

    @Override
    public boolean equals(Object that) {
      if (that == null)
        return false;
      if (that instanceof storeMultiRecord_result)
        return this.equals((storeMultiRecord_result)that);
      return false;
    }

    public boolean equals(storeMultiRecord_result that) {
      if (that == null)
        return false;

      boolean this_present_ssex = true && this.isSetSsex();
      boolean that_present_ssex = true && that.isSetSsex();
      if (this_present_ssex || that_present_ssex) {
        if (!(this_present_ssex && that_present_ssex))
          return false;
        if (!this.ssex.equals(that.ssex))
          return false;
      }

      return true;
    }

    @Override
    public int hashCode() {
      HashCodeBuilder builder = new HashCodeBuilder();

      boolean present_ssex = true && (isSetSsex());
      builder.append(present_ssex);
      if (present_ssex)
        builder.append(ssex);

      return builder.toHashCode();
    }

    public int compareTo(storeMultiRecord_result other) {
      if (!getClass().equals(other.getClass())) {
        return getClass().getName().compareTo(other.getClass().getName());
      }

      int lastComparison = 0;
      storeMultiRecord_result typedOther = (storeMultiRecord_result)other;

      lastComparison = Boolean.valueOf(isSetSsex()).compareTo(typedOther.isSetSsex());
      if (lastComparison != 0) {
        return lastComparison;
      }
      if (isSetSsex()) {        lastComparison = TBaseHelper.compareTo(this.ssex, typedOther.ssex);
        if (lastComparison != 0) {
          return lastComparison;
        }
      }
      return 0;
    }

    public void read(TProtocol iprot) throws TException {
      TField field;
      iprot.readStructBegin();
      while (true)
      {
        field = iprot.readFieldBegin();
        if (field.type == TType.STOP) { 
          break;
        }
        switch (field.id) {
          case 1: // SSEX
            if (field.type == TType.STRUCT) {
              this.ssex = new edu.illinois.cs.cogcomp.thrift.base.ServiceSecurityException();
              this.ssex.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          default:
            TProtocolUtil.skip(iprot, field.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      validate();
    }

    public void write(TProtocol oprot) throws TException {
      oprot.writeStructBegin(STRUCT_DESC);

      if (this.isSetSsex()) {
        oprot.writeFieldBegin(SSEX_FIELD_DESC);
        this.ssex.write(oprot);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

    @Override
    public String toString() {
      StringBuilder sb = new StringBuilder("storeMultiRecord_result(");
      boolean first = true;

      sb.append("ssex:");
      if (this.ssex == null) {
        sb.append("null");
      } else {
        sb.append(this.ssex);
      }
      first = false;
      sb.append(")");
      return sb.toString();
    }

    public void validate() throws TException {
      // check for required fields
    }

  }

}
